
var BerUI = require("../../index");

// ====

var Separator = (function() {
    //

    //
    class Separator extends BerUI.BasePanel {
        constructor(parentView, options) {
            super(parentView, options);
            var _this = this;


            // == ui ==


            // == methods ==


            // == events ==


        }

        init() {
            super.init();

            //
            this.look.value = {
                borderRadius: 4,
                color: BerColor.Bright,

                // size: 2,
                lineHeightPx: 2,
                lineWidthPct: 90,
                lineBorderRadius: 0,
            };

            // == ui ==
            var cellValue = new BerUI.BasePanel(this);
            var seprator = new BerUI.BasePanel(cellValue);

            //
            this.cellValue = cellValue;
            this.seprator = seprator;

        }

        redrawLook() {
            super.redrawLook();

            var valueLook = this.look.value;

            // this.cellValue.setLook({
            //     padding: valueLook.padding
            // });

            this.seprator.setRect({
                //
                x: (100 - valueLook.lineWidthPct) / 2,
                w: valueLook.lineWidthPct,
                //
                y: (this.cellValue.PxH - this.look.value.lineHeightPx) / 2 + "px",
                h: this.look.value.lineHeightPx + "px"
            });
            this.seprator.setLook({
                borderRadius: valueLook.borderRadius,
                bgColor: valueLook.color,
            });

        }

        //
        set Value(val) {
            this.look.value.color = val;
            this.redrawLook();
        }
        get Value() {
            return this.txtValue.Value;
        }


    }


    //
    return Separator;
})();


//
module.exports = Separator;
