
var BerUI = require("../../index");

// ====

var TextWithArrow = (function() {
    //

    //
    class TextWithArrow extends BerUI.BasePanel {
        constructor(parentView, options) {
            super(parentView, options);
            var _this = this;


            // == ui ==


            // == methods ==


            // == events ==


        }

        init() {
            super.init();

            //
            this.look.value = {
                txt: "",
                txtColor: BerColor.Darker,
                bgColor: BerColor.Transparent,
                txtAlign: "left",
                txtScale: 0.4,

                padding: 2,
                borderRadius: 4

            };

            // == ui ==

            // TODO:  value 部分不見了, 待解


            var cellValue = new BerUI.BasePanel(this);

            var cellBG = new BerUI.BasePanel(cellValue);

            var txtValue = new BerUI.TextView(cellBG, {
                rect: { w: 80 }
            });

            var txtArrow = new BerUI.TextView(cellBG, {
                rect: { x: 80, w: 20 }
            });

            //
            this.cellValue = cellValue;
            this.cellBG = cellBG;
            this.txtValue = txtValue;
            this.txtArrow = txtArrow;

        }

        redrawLook() {
            super.redrawLook();

            var valueLook = this.look.value;

            this.cellValue.setLook({
                padding: valueLook.padding,
            });

            this.cellBG.setLook({
                borderRadius: valueLook.borderRadius,
                bgColor: valueLook.bgColor,
            });

            this.txtValue.setLook({
                txtColor: valueLook.txtColor,
                txtScale: valueLook.txtScale,
                txtAlign: valueLook.txtAlign,
                txt: valueLook.txt,
            });

            this.txtArrow.setLook({
                txtColor: valueLook.txtColor,
                txtScale: valueLook.txtScale,
                txtAlign: valueLook.txtAlign,
                txt: "▼",
            });

        }

        //
        set Value(val) {
            this.look.value.txt = val;
            this.txtValue.Value = val;
        }
        get Value() {
            return this.txtValue.Value;
        }


    }


    //
    return TextWithArrow;
})();


//
module.exports = TextWithArrow;
