
var BerUI = require("../../index");
var Text = require("./Text");
var DropdownButton = require("./DropdownButton");

// ====

var TitleDropdownButton = (function() {
    //

    //
    class TitleDropdownButton extends DropdownButton {
        constructor(parentView, options) {
            super(parentView, options);
            var _this = this;


            // == ui ==


            // == methods ==


            // == events ==


        }

        init() {
            super.init();

            //
            this.look.title = {
                txt: "",
                txtColor: BerColor.Mid,
                bgColor: BerColor.Transparent,
                txtAlign: "left",
                txtScale: 0.7,

                padding: 0,
                borderRadius: 0
            };


            // == ui ==
            var title = new Text(this, {
                rect: { h: 30 }
            });

            this.cellValue.setRect({ y: 30, h: 70 });


            //
            this.title = title;

        }

        redrawLook() {
            super.redrawLook();

            if(this.look.title) this.title.setLook({ value: this.look.title });

        }

        //
        set Title(val) {
            this.look.title.txt = val;
            this.title.Value = val;
        }
        get Title() {
            return this.title.Value;
        }

    }


    //
    return TitleDropdownButton;
})();


//
module.exports = TitleDropdownButton;
