
var CoreView = require("../core/CoreView");

// ====

var IFrameView = (function() {
    //

    //
    class IFrameView extends CoreView {
        constructor(parentView, options) {
            super("iframe", parentView, options);
            var _this = this;

            // == events ==
            this.domOn("load", function() {
                _this.emit("load", event);
            });

        }

        // == init ==
        init(options) {
            super.init();

            // look
            this.look.src = "";

        }


        // == redraw ==

        // look
        redrawLook() {
            super.redrawLook();

            this.core.src = this.look.src;

        }


    }


    //
    return IFrameView;
})();


//
module.exports = IFrameView;
