
var CoreView = require("../core/CoreView");

// ====

var ImageView = (function() {
    //

    //
    class ImageView extends CoreView {
        constructor(parentView, options) {
            super("img", parentView, options);
            var _this = this;

            // == events ==
            this.domOn("load", function() {
                _this.emit("load", event);
            });

        }

        // == init ==
        init(options) {
            super.init();

            // look
            this.look.src = "";

        }


        // == redraw ==

        // look
        redrawLook() {
            super.redrawLook();

            this.core.src = this.look.src;

        }


        // == getter ==
        get Value() {
            return this.core.value;
        }


    }


    //
    return ImageView;
})();


//
module.exports = ImageView;
