
var CoreView = require("../core/CoreView");

// ====

var SimpleCanvas = (function() {

    //
    class SimpleCanvas extends CoreView {
        constructor(parentView, options) {
            super("canvas", parentView, options);
            var _this = this;


            // == methods ==

            function clear() {
                var _context2D = _this.core.getContext("2d");
                _context2D.clearRect(0, 0, _this.core.width, _this.core.height);
            }
            function fillColor(color) {
                var _context2D = _this.core.getContext("2d");
                _context2D.fillStyle = color;
                _context2D.fillRect(0, 0, _this.core.width, _this.core.height);
            }
            //
            this.clear = clear;
            this.fillColor = fillColor;


            // == events ==
            this.on("redraw", function() {

                _this.core.width = _this.PxW;
                _this.core.height = _this.PxH;

            });

        }

        init(options) {
            super.init();


        }




    }


    //
    return SimpleCanvas;
})();


//
module.exports = SimpleCanvas;
