(function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){

var TextView = require("./TextView");

// ====

var ButtonView = (function() {
    //

    //
    class ButtonView extends TextView {
        constructor(parentView, options) {
            super(parentView, options);
            var _this = this;

            //
            function updateLook() {
                if(_this.anim.isAnimating()) return; // NOTE 不然 bgColor 和 txtColor 的動畫會被下面的設定干擾
                //
                if(_this.opts.disabled) {
                    _this.setLook({
                        bgColor: _this.look.bgDisabled,
                        txtColor: _this.look.txtDisabled,
                        bgImage: _this.look.imgDisabled
                    });

                } else {
                    switch (_this.state) {
                        case "enter":
                            _this.setLook({
                                bgColor: _this.look.bgEnter,
                                txtColor: _this.look.txtEnter,
                                bgImage: _this.look.imgEnter
                            });
                            break;

                        case "down":
                            _this.setLook({
                                bgColor: _this.look.bgDown,
                                txtColor: _this.look.txtDown,
                                bgImage: _this.look.imgDown
                            });
                            break;

                        default:   // normal
                            _this.setLook({
                                bgColor: _this.look.bgNormal,
                                txtColor: _this.look.txtNormal,
                                bgImage: _this.look.imgNormal
                            });

                    }

                }

            }


            // == events ==
            // mouse
            this.domOn("click", function() {
                if(_this.opts.disabled) return;
                _this.emit("click", _this); // NOTE mouse 跟 touch 統一在這邊轉換 (總之會都從這裡發出)
            });
            this.domOn("mouseleave", function() {
                if(_this.opts.disabled) return;
                _this.mouseover = false;
                _this.state = "normal";
                updateLook();
            });
            this.domOn("mouseenter", function() {
                if(_this.opts.disabled) return;
                _this.mouseover = true;
                _this.state = "enter";
                updateLook();
            });
            this.domOn("mousedown", function() {
                if(_this.opts.disabled) return;
                _this.state = "down";
                updateLook();
                // _this.emit("click", _this);
            });
            this.domOn("mouseup", function() {
                if(_this.opts.disabled) return;
                if(_this.mouseover) {
                    _this.state = "enter";
                } else {
                    _this.state = "normal";
                }
                updateLook();
            });

            // touch
            this.domOn("touchstart", function() {
                if(_this.opts.disabled) return;
                _this.state = "down";
                updateLook();
                // _this.emit("click", _this);  // NOTE touch 系列在 CoreView 有針對 click 事件做轉換, 故在此不用管 (否則會變成送出兩次)
            });
            this.domOn("touchend", function() {
                if(_this.opts.disabled) return;
                _this.mouseover = false;
                _this.state = "normal";
                updateLook();
            });
            this.domOn("touchmove", function() {
                if(_this.opts.disabled) return;
                _this.mouseover = false;
                _this.state = "normal";
                updateLook();
            });

            //
            this.on("anim_end", function() {
                _this.redraw();
            });

        }

        // == init ==
        init(options) {
            super.init();

            // extend
            this.look.bgNormal = "rgb(106, 192, 215)";
            this.look.bgEnter = "rgb(200, 200, 200)";
            this.look.bgDown = "rgb(100, 100, 100)";
            this.look.bgDisabled = "rgb(200, 200, 200)";
            this.look.txtNormal = "rgb(240, 240, 240)";
            this.look.txtEnter = "rgb(100, 100, 100)";
            this.look.txtDown = "rgb(200, 200, 200)";
            this.look.txtDisabled = "rgb(220, 220, 220)";
            this.look.imgNormal = null;
            this.look.imgEnter = null;
            this.look.imgDown = null;
            this.look.imgDisabled = null;

            // inherit
            this.opts.cursor = "pointer";   // 改預設值, 非新增

            //
            this.state = "normal";          // normal, enter, down
            this.mouseover = false;

        }


        // == redraw ==

        // look
        redrawLook() {
            if(this.anim.isAnimating()) { // NOTE 不然 bgColor 和 txtColor 的動畫會被下面的設定干擾
                super.redrawLook();

            } else {
                //
                if(this.opts.disabled) {
                    this.look.bgColor = this.look.bgDisabled;
                    this.look.txtColor = this.look.txtDisabled;
                    this.look.bgImage = this.look.imgDisabled;

                } else {
                    switch (this.state) {
                        case "enter":
                            this.look.bgColor = this.look.bgEnter;
                            this.look.txtColor = this.look.txtEnter;
                            this.look.bgImage = this.look.imgEnter;
                            break;

                        case "down":
                            this.look.bgColor = this.look.bgDown;
                            this.look.txtColor = this.look.txtDown;
                            this.look.bgImage = this.look.imgDown;
                            break;

                        default:   // normal
                            this.look.bgColor = this.look.bgNormal;
                            this.look.txtColor = this.look.txtNormal;
                            this.look.bgImage = this.look.imgNormal;

                    }
                }

                //
                super.redrawLook();
            }

        }


        //
        get Value() {
            return this.look.txt;
        }
        set Value(val) {
            this.setLook({ txt: val });
        }


        // ====
        show() {
            this.setOpts({ visible: true });
        }
        hide() {
            this.setOpts({ visible: false });
        }

        setDisabled(disabled) {
            this.setOpts({ disabled: disabled });
            this.redraw(true);
        }

    }


    //
    return ButtonView;
})();


//
module.exports = ButtonView;

},{"./TextView":4}],2:[function(require,module,exports){

var CoreView = require("../core/CoreView");

// ====

var DivView = (function() {
    //

    //
    class DivView extends CoreView {
        constructor(parentView, options) {
            super("div", parentView, options);
            var _this = this;

            // NOTE events
            // [atRight] 捲到最右時 emit
            // [atBottom] 捲到底時 emit
            this.domOn("scroll", function() {
                //
                _this.scroll.x = _this.core.scrollLeft;
                _this.scroll.y = _this.core.scrollTop;

                // left
                if(_this.core.scrollLeft == 0) {
                    if(!_this.isAtLeft) {
                        _this.isAtLeft = true;
                        _this.emit("atLeft");
                    }

                } else {
                    _this.isAtLeft = false;
                }

                // top
                if(_this.core.scrollTop == 0) {
                    if(!_this.isAtTop) {
                        _this.isAtTop = true;
                        _this.emit("atTop");
                    }

                } else {
                    _this.isAtTop = false;
                }

                // right
                if((_this.core.scrollWidth - (_this.core.clientWidth + _this.core.scrollLeft)) == 0) {
                    if(!_this.isAtRight) {
                        _this.isAtRight = true;
                        _this.emit("atRight");
                    }

                } else {
                    _this.isAtRight = false;
                }

                // bottom
                if(( _this.core.scrollHeight - (_this.core.clientHeight + _this.core.scrollTop) ) == 0) {
                    if(!_this.isAtBottom) {
                        _this.isAtBottom = true;
                        _this.emit("atBottom");
                    }

                } else {
                    _this.isAtBottom = false;
                }

            });

        }

        // == init ==
        init() {
            super.init();

            //
            this.core.style.overflowX = "hidden";
            this.core.style.overflowY = "hidden";

            //
            // NOTE visible 要兩個一起才有用, 否則單個 visible 會變成 scroll
            this.overflow = {
                x: "hidden",    // hidden, visible, scroll
                y: "hidden"
            };
            this.scroll = {
                x: 0,
                y: 0
            };

            this.isAtTop = true;
            this.isAtLeft = true;
            this.isAtRight = false;
            this.isAtBottom = false;

        }
        setOptions(options) {
            super.setOptions(options);
            //
            // NOTE 自己專有的部分直接執行就好
            if(isUsable(options)) {
                if(isUsable(options.overflow)) this.setOverflow(options.overflow);
                if(isUsable(options.scroll)) this.setScroll(options.scroll);
            }
        }

        // == redraw ==

        // overflow // NOTE visible 要兩個一起才有用, 否則單個 visible 會變成 scroll
        setOverflow(overflow, setOnly) {
            assignToTargetOwnProps(overflow, this.overflow);
            if(!(isUsable(setOnly) && setOnly)) this.redrawOverflow();
        }
        redrawOverflow() {
            this.core.style.overflowX = this.overflow.x;
            this.core.style.overflowY = this.overflow.y;
        }

        // scroll
        setScroll(scroll, setOnly) {
            assignToTargetOwnProps(scroll, this.scroll);
            if(!(isUsable(setOnly) && setOnly)) this.redrawScroll();
        }
        redrawScroll() {
            // x
            if(this.scroll.x == "max") {
                this.scrollToRight();
            } else {
                this.core.scrollLeft = this.scroll.x;
            }

            // y
            if(this.scroll.y == "max") {
                this.scrollToBottom();
            } else {
                this.core.scrollTop = this.scroll.y;
            }

        }
        scrollToTop() {
            this.core.scrollTop = 0;
        }
        scrollToBottom() {
            this.core.scrollTop = this.core.scrollHeight;
        }
        scrollToLeft() {
            this.core.scrollLeft = 0;
        }
        scrollToRight() {
            this.core.scrollLeft = this.core.scrollWidth;
        }


    }


    //
    return DivView;
})();


//
module.exports = DivView;

},{"../core/CoreView":7}],3:[function(require,module,exports){

var DivView = require("./DivView");

// ====

var RootView = (function() {
    //
    function BodyView() {
        var _this = this;

        this.core = document.body;

        this.getPxW = function () {
            return document.documentElement.offsetWidth;
        }
        this.getPxH = function () {
            return document.documentElement.offsetHeight;
        }

        this.childViews = [];
        this.addChildView = function (view) {
            _this.core.appendChild(view.core);
            _this.childViews.push(view);
        }
        this.redrawChildViews = function() {
            for(var i=0; i<_this.childViews.length; i++) {
                if(_this.childViews[i].redraw) _this.childViews[i].redraw(true);
            }
        }

        // NOTE 當這串在此 class 內執行時, CoreView 的 redraw 的 emit, 只觸發了宣告在其 constructor 內的 on, 沒觸發其 instance 宣告在外面的 on
        // TODO 有空要釐清這個問題 (目前把這拉到最外面即可避免)
        // NOTE 總之為了確保觸發由 instance 宣告的 on, 盡量把會觸發該事件的 call 也放在外面 (外面指的是繼承 EventEmitter 的物件之外)
        // NOTE >>>> 先改回來觀察 <<<<< NOTE
        this.autoResizeChild = true;
        window.addEventListener("resize", function () {
            if (_this.autoResizeChild) _this.redrawChildViews();
        }, false);


        // window.addEventListener('orientationchange', function() {
        //     // switch(window.orientation)  {
        //     //     case -90:
        //     //     case 90:
        //     //         alert('landscape');
        //     //         break;
        //     //     default:
        //     //         alert('portrait');
        //     //     break;
        //     // }
        //
        //     // console.log('orientationchange');
        //     //if (_this.autoResizeChild) {
        //         for (var i = 0; i < _this.childViews.length; i++) {
        //             // console.log('redraw');
        //             _this.childViews[i].redraw();
        //         }
        //     //}
        //
        // });

    }

    //
    class RootView extends DivView {
        constructor() {
            var bodyView = new BodyView();
            super(bodyView);


            // this.setAutoResizeChild = function (auto) {
            //     bodyView.autoResizeChild = auto;
            // }

            this.getBodyView = function() {
                return bodyView;
            }

            //
            // this.emit("root");

        }

        // //
        // emit() {
        //     console.log("[root][emit]", arguments[0]);
        //     super.emit.apply(this, arguments);
        // }

    }


    //
    return RootView;
})();



//
module.exports = RootView;

},{"./DivView":2}],4:[function(require,module,exports){

var CoreView = require("../core/CoreView");

// ====

var TextView = (function() {
    //

    //
    class TextView extends CoreView {
        constructor(parentView, options) {
            super("div", parentView, options);
            var _this = this;

        }

        // == init ==
        init(options) {
            super.init();

            //
            this.core.style.overflowX = "hidden";
            this.core.style.overflowY = "hidden";

            // look
            this.look.txt = "";
            this.look.txtSize = 0;                      // NOTE 0 時會自動計算文字尺寸. 大於 0 則會以此值為固定尺寸.
            this.look.txtScale = 0.5;                   // NOTE 此值是個比例. 預設值會根據元件高度變動.
            this.look.txtColor = "rgb(255, 255, 255)";
            this.look.txtAlign = "center";              // left, right, center, justify
            this.look.txtShadow = {
                h: 0,
                v: 0,
                blur: 1,
                color: "rgba(0, 0, 0, 0)"
            };


        }


        // == redraw ==

        // look
        redrawLook() {
            super.redrawLook();

            this.core.innerHTML = this.look.txt;
            this.core.style.color = this.look.txtColor;
            this.core.align = this.look.txtAlign;
            this.core.style.textShadow = this.look.txtShadow.h + "px " + this.look.txtShadow.v + "px " + this.look.txtShadow.blur + "px " + this.look.txtShadow.color;

            if(this.look.txtSize == 0) {
                // 自動
                this.core.style.fontSize = (this.PxH * this.look.txtScale) + "px";
            } else {
                // 定值
                this.core.style.fontSize = this.look.txtSize + "px";
            }

            this.core.style.lineHeight = (this.PxH - this.look.padding*2) + "px";

        }

        //
        get Value() {
            return this.look.txt;
        }
        set Value(val) {
            this.setLook({ txt: val });
        }

    }


    //
    return TextView;
})();


//
module.exports = TextView;

},{"../core/CoreView":7}],5:[function(require,module,exports){

var TextView = require("./TextView");

// ====

var ToggleView = (function() {
    //

    //
    class ToggleView extends TextView {
        constructor(parentView, options) {
            super(parentView, options);
            var _this = this;

            var active = false;
            var radioIndex = null;
            var radioGroup = null;

            //
            function initRadio(index, group) {
                radioIndex = index;
                radioGroup = group;
            }
            function setActive(act, mode) {
                active = act;
                update(mode);
            }
            function getActive(act) {
                return active;
            }
            function getRadioIndex() {
                return radioIndex;
            }
            function update(mode) {
                if(active) {
                    _this.setLook({
                        bgColor: _this.look.active.bgColor,
                        txtColor: _this.look.active.txtColor,
                        bgImage: _this.look.active.bgImage
                    });
                } else {
                    _this.setLook({
                        bgColor: _this.look.inactive.bgColor,
                        txtColor: _this.look.inactive.txtColor,
                        bgImage: _this.look.inactive.bgImage
                    });
                }

                if(active && radioGroup) {
                    for(var i=0; i<radioGroup.length; i++) {
                        if(radioGroup[i].getRadioIndex() != radioIndex) {
                            radioGroup[i].setActive(false);
                        }
                    }
                }

                // ==
                if(!isUsable(mode) || mode != "quiet") {

                    _this.emit("toggle", active);
                    if(active) {
                        _this.emit("toggleOn");
                    } else {
                        _this.emit("toggleOff");
                    }

                }

            }
            function toggle() {
                if(radioGroup && active) {
                    // 若有設定 radioGroup 且 active, 則不切換狀態
                } else {
                    active = !active;
                    update();
                }
            }
            //
            this.initRadio = initRadio;
            this.setActive = setActive;
            this.getActive = getActive;
            this.getRadioIndex = getRadioIndex;
            this.toggle = toggle;


            // == events ==
            // mouse
            this.domOn("mousedown", function() {
                toggle();
            });

            // touch
            this.domOn("touchstart", function() {
                toggle();
            });


            // ==
            update(); // for init NOTE TODO  not work

        }

        // == init ==
        init(options) {
            super.init();

            // look
            this.look.inactive = {
                txt: null,
                bgColor: null,
                txtColor: null,
                bgImage: null
            };
            this.look.active = {
                txt: null,
                bgColor: null,
                txtColor: null,
                bgImage: null
            };

            // opts
            this.opts.cursor = "pointer"; // 改預設值, 非新增

        }


        // == redraw ==

        // look
        redrawLook() {
            if(isUsable(this.getActive) && this.getActive()) {
                this.look.txt = this.look.active.txt;
                this.look.bgColor = this.look.active.bgColor;
                this.look.txtColor = this.look.active.txtColor;
                this.look.bgImage = this.look.active.bgImage;
            } else {
                this.look.txt = this.look.inactive.txt;
                this.look.bgColor = this.look.inactive.bgColor;
                this.look.txtColor = this.look.inactive.txtColor;
                this.look.bgImage = this.look.inactive.bgImage;
            }

            //
            super.redrawLook();

        }


    }


    //
    return ToggleView;
})();


//
module.exports = ToggleView;

},{"./TextView":4}],6:[function(require,module,exports){

var EventEmitter = require("./EventEmitter");

// ====

// NOTE transform 的 translate 系列, 元件的 rect 必須設定在顯示中該出現的位置. 若預設是藏起來的, 則在初始時用 transform 來藏.

var Animation = (function() {
    //
    function getRGBA(colorStr) {
        var color = {
            r: 0,
            g: 0,
            b: 0,
            a: 1
        };
        var str = colorStr.trim().toLowerCase();
        var temp = str.split("(")[1];
        temp = temp.split(")")[0];
        temp = temp.split(",");

        if(str.startsWith("rgba")) {
            if(temp.length != 4) return null;
            color.r = parseInt(temp[0]);
            color.g = parseInt(temp[1]);
            color.b = parseInt(temp[2]);
            color.a = parseInt(temp[3]);

        } else if(str.startsWith("rgb")) {
            if(temp.length != 3) return null;
            color.r = parseInt(temp[0]);
            color.g = parseInt(temp[1]);
            color.b = parseInt(temp[2]);

        } else {
            return null;
        }

        return color;

        // TODO 現在只能處理一種字串 ( rgb(x,x,x) & rgba(x,x,x,x) ) , 待擴充
    }

    //
    class Animation extends EventEmitter {
        constructor(view) {
            super();

            var _this = this;
            var view = view;

            var run = false;
            var duration = 500;
            var startTime = null;
            var passingTime = null;
            var progress = null;       // 0~1

            var current;
            var queue = [];

            var loop = false;

            // ====

            function setAnimaion(anim) {
                // core
                var newAnim = {};
                newAnim.duration = (isUsable(anim.duration) ? anim.duration : 500);

                // NOTE 當 anim 裡的某組值, 至少一個有被設定, 而其他沒被設定時(例: anim.transform.translateX 有值, 但 translateY 及 translateZ 沒有), 沒被設定的值需要從 view 取.
                //      但 animation 有可能是透過 setAnimaions 一次設定多組.
                //      此時上述沒被設定的值, 若在此處透過 view 來取, 就只能取到第一個 animation 執行前的值. 可能會不符合實際狀況.
                //      因此發生上述狀況時, 要在 animate 處才取值.
                // NOTE 上述的一組, 指的是像 anim.visibility 或 anim.transform, 各自為一組.

                // visibility
                if(isUsable(anim.visibility)) {
                    newAnim.visibility = {};
                    newAnim.visibility.toValue = anim.visibility;
                }

                // transform
                if(isUsable(anim.transform)) {
                    newAnim.transform = {};

                    // translate
                    if(isUsable(anim.transform.translateX)) newAnim.transform.toTranslateX = anim.transform.translateX;
                    if(isUsable(anim.transform.translateY)) newAnim.transform.toTranslateY = anim.transform.translateY;
                    if(isUsable(anim.transform.translateZ)) newAnim.transform.toTranslateZ = anim.transform.translateZ;

                    // rotate
                    if(isUsable(anim.transform.rotateX)) newAnim.transform.toRotateX = anim.transform.rotateX;
                    if(isUsable(anim.transform.rotateY)) newAnim.transform.toRotateY = anim.transform.rotateY;
                    if(isUsable(anim.transform.rotateZ)) newAnim.transform.toRotateZ = anim.transform.rotateZ;

                    // scale
                    if(isUsable(anim.transform.scale)) newAnim.transform.toScale = anim.transform.scale;

                    // skew
                    if(isUsable(anim.transform.skewX)) newAnim.transform.toSkewX = anim.transform.skewX;
                    if(isUsable(anim.transform.skewY)) newAnim.transform.toSkewY = anim.transform.skewY;

                }

                // bgColor
                if(isUsable(anim.bgColor)) {
                    var color = getRGBA(anim.bgColor);
                    if(color) {
                        newAnim.bgColor = {};
                        newAnim.bgColor.toR = color.r;
                        newAnim.bgColor.toG = color.g;
                        newAnim.bgColor.toB = color.b;
                        newAnim.bgColor.toA = color.a;
                    } else {
                        console.warn("[Animation] invalid backgroundColor");
                    }
                }

                // txtColor
                if(isUsable(anim.txtColor)) {
                    var color = getRGBA(anim.txtColor);
                    if(color) {
                        newAnim.txtColor = {};
                        newAnim.txtColor.toR = color.r;
                        newAnim.txtColor.toG = color.g;
                        newAnim.txtColor.toB = color.b;
                        newAnim.txtColor.toA = color.a;
                    } else {
                        console.warn("[Animation] invalid textColor");
                    }
                }

                // boxShadow
                if(isUsable(anim.boxShadow)) {
                    newAnim.boxShadow = {};

                    // h
                    if(isUsable(anim.boxShadow.h)) newAnim.boxShadow.toH = anim.boxShadow.h;

                    // v
                    if(isUsable(anim.boxShadow.v)) newAnim.boxShadow.toV = anim.boxShadow.v;

                    // blur
                    if(isUsable(anim.boxShadow.blur)) newAnim.boxShadow.toBlur = anim.boxShadow.blur;

                    // spread
                    if(isUsable(anim.boxShadow.spread)) newAnim.boxShadow.toSpread = anim.boxShadow.spread;

                    // color
                    if(isUsable(anim.boxShadow.color)) {
                        var color = getRGBA(anim.boxShadow.color);
                        if(color) {
                            newAnim.boxShadow.color = {};
                            newAnim.boxShadow.color.toR = color.r;
                            newAnim.boxShadow.color.toG = color.g;
                            newAnim.boxShadow.color.toB = color.b;
                            newAnim.boxShadow.color.toA = color.a;
                        } else {
                            console.warn("[Animation] invalid boxShadow color");
                        }
                    }

                    // inset 不納入動畫

                }

                // scroll
                if(isUsable(anim.scroll)) {
                    newAnim.scroll = {};

                    // x
                    if(isUsable(anim.scroll.x)) newAnim.scroll.toX = anim.scroll.x;

                    // y
                    if(isUsable(anim.scroll.y)) newAnim.scroll.toY = anim.scroll.y;

                }

                // core
                queue.push(newAnim);

            }
            function setAnimaions(anims) {
                for(var i=0; i<anims.length; i++) {
                    setAnimaion(anims[i]);
                }
            }

            function play(anim) {
                if(Array.isArray(anim)) {
                    setAnimaions(anim);
                } else {
                    setAnimaion(anim);
                }

                //
                run = true;
                animate();
            }
            function animate() {
                // core
                if(!current) {
                    if(queue.length == 0) return;
                    current = queue.shift();
                    startTime = new Date().getTime();
                }
                passingTime = (new Date().getTime() - startTime);
                progress = (passingTime / current.duration);

                // visibility
                if(current.visibility) {
                    // 因為要從 view 取值, 當有 queue 時 view 的值可能因為其他段動畫有變動, 所以必須在這裡取
                    if(!isUsable(current.visibility.fromValue)) current.visibility.fromValue = parseFloat(view.core.style.opacity);
                    if(!isUsable(current.visibility.totalOffset)) current.visibility.totalOffset = (current.visibility.toValue - current.visibility.fromValue);
                    //
                    if(current.visibility.fromValue == 0 && current.visibility.toValue != 0) view.core.style.display = "block";
                    // NOTE 底下註解掉的部分, 是剛要開始做 "當目標值跟現在一樣時, 不再做無謂的計算"
                    // TODO 應該對效能有幫助, 待完成, 並套用到類似地方
                    // if(current.visibility.totalOffset == 0) {
                    //     view.core.style.opacity = current.visibility.toValue;
                    // } else {
                        view.core.style.opacity = current.visibility.fromValue + (current.visibility.totalOffset * progress);
                    // }
                }

                // transform
                if(current.transform) {
                    // translateX
                    if(!isUsable(current.transform.toTranslateX)) current.transform.toTranslateX = view.transform.translateX; //
                    if(!isUsable(current.transform.fromTranslateX)) current.transform.fromTranslateX = view.transform.translateX;
                    if(!isUsable(current.transform.totalOffsetTranslateX)) current.transform.totalOffsetTranslateX = (current.transform.toTranslateX - current.transform.fromTranslateX);
                    var translateX = (current.transform.fromTranslateX + (current.transform.totalOffsetTranslateX * progress));

                    // translateY
                    if(!isUsable(current.transform.toTranslateY)) current.transform.toTranslateY = view.transform.translateY; //
                    if(!isUsable(current.transform.fromTranslateY)) current.transform.fromTranslateY = view.transform.translateY;
                    if(!isUsable(current.transform.totalOffsetTranslateY)) current.transform.totalOffsetTranslateY = (current.transform.toTranslateY - current.transform.fromTranslateY);
                    var translateY = (current.transform.fromTranslateY + (current.transform.totalOffsetTranslateY * progress));

                    // translateZ
                    if(!isUsable(current.transform.toTranslateZ)) current.transform.toTranslateZ = view.transform.translateZ; //
                    if(!isUsable(current.transform.fromTranslateZ)) current.transform.fromTranslateZ = view.transform.translateZ;
                    if(!isUsable(current.transform.totalOffsetTranslateZ)) current.transform.totalOffsetTranslateZ = (current.transform.toTranslateZ - current.transform.fromTranslateZ);
                    var translateZ = (current.transform.fromTranslateZ + (current.transform.totalOffsetTranslateZ * progress));

                    // rotateX
                    if(!isUsable(current.transform.toRotateX)) current.transform.toRotateX = view.transform.rotateX; //
                    if(!isUsable(current.transform.fromRotateX)) current.transform.fromRotateX = view.transform.rotateX;
                    if(!isUsable(current.transform.totalOffsetRotateX)) current.transform.totalOffsetRotateX = (current.transform.toRotateX - current.transform.fromRotateX);
                    var rotateX = (current.transform.fromRotateX + (current.transform.totalOffsetRotateX * progress));

                    // rotateY
                    if(!isUsable(current.transform.toRotateY)) current.transform.toRotateY = view.transform.rotateY; //
                    if(!isUsable(current.transform.fromRotateY)) current.transform.fromRotateY = view.transform.rotateY;
                    if(!isUsable(current.transform.totalOffsetRotateY)) current.transform.totalOffsetRotateY = (current.transform.toRotateY - current.transform.fromRotateY);
                    var rotateY = (current.transform.fromRotateY + (current.transform.totalOffsetRotateY * progress));

                    // rotateZ
                    if(!isUsable(current.transform.toRotateZ)) current.transform.toRotateZ = view.transform.rotateZ; //
                    if(!isUsable(current.transform.fromRotateZ)) current.transform.fromRotateZ = view.transform.rotateZ;
                    if(!isUsable(current.transform.totalOffsetRotateZ)) current.transform.totalOffsetRotateZ = (current.transform.toRotateZ - current.transform.fromRotateZ);
                    var rotateZ = (current.transform.fromRotateZ + (current.transform.totalOffsetRotateZ * progress));

                    // scale
                    if(!isUsable(current.transform.toScale)) current.transform.toScale = view.transform.scale; //
                    if(!isUsable(current.transform.fromScale)) current.transform.fromScale = view.transform.scale;
                    if(!isUsable(current.transform.totalOffsetScale)) current.transform.totalOffsetScale = (current.transform.toScale - current.transform.fromScale);
                    var scale = (current.transform.fromScale + (current.transform.totalOffsetScale * progress));

                    // skewX
                    if(!isUsable(current.transform.toSkewX)) current.transform.toSkewX = view.transform.skewX; //
                    if(!isUsable(current.transform.fromSkewX)) current.transform.fromSkewX = view.transform.skewX;
                    if(!isUsable(current.transform.totalOffsetSkewX)) current.transform.totalOffsetSkewX = (current.transform.toSkewX - current.transform.fromSkewX);
                    var skewX = (current.transform.fromSkewX + (current.transform.totalOffsetSkewX * progress));

                    // skewY
                    if(!isUsable(current.transform.toSkewY)) current.transform.toSkewY = view.transform.skewY; //
                    if(!isUsable(current.transform.fromSkewY)) current.transform.fromSkewY = view.transform.skewY;
                    if(!isUsable(current.transform.totalOffsetSkewY)) current.transform.totalOffsetSkewY = (current.transform.toSkewY - current.transform.fromSkewY);
                    var skewY = (current.transform.fromSkewY + (current.transform.totalOffsetSkewY * progress));

                    //
                    view.setTransform({
                        translateX: translateX,
                        translateY: translateY,
                        translateZ: translateZ,
                        rotateX: rotateX,
                        rotateY: rotateY,
                        rotateZ: rotateZ,
                        scale: scale,
                        skewX: skewX,
                        skewY: skewY
                    });

                }

                // bgColor
                if(current.bgColor) {
                    var fromColor;
                    if(!isUsable(current.bgColor.fromR) || !isUsable(current.bgColor.fromG) || !isUsable(current.bgColor.fromB) || !isUsable(current.bgColor.fromA)) {
                        if(view.look.bgColor) {
                            fromColor = getRGBA(view.look.bgColor);
                        } else {
                            // 若 view 沒設定過 bgColor, 就從透明開始
                            fromColor = {
                                r: current.bgColor.toR,
                                g: current.bgColor.toG,
                                b: current.bgColor.toB,
                                a: 0
                            }
                        }
                    }

                    // r
                    if(!isUsable(current.bgColor.fromR)) current.bgColor.fromR = fromColor.r;
                    if(!isUsable(current.bgColor.totalOffsetR)) current.bgColor.totalOffsetR = (current.bgColor.toR - current.bgColor.fromR);
                    var r = parseInt(current.bgColor.fromR + (current.bgColor.totalOffsetR * progress));

                    // g
                    if(!isUsable(current.bgColor.fromG)) current.bgColor.fromG = fromColor.g;
                    if(!isUsable(current.bgColor.totalOffsetG)) current.bgColor.totalOffsetG = (current.bgColor.toG - current.bgColor.fromG);
                    var g = parseInt(current.bgColor.fromG + (current.bgColor.totalOffsetG * progress));

                    // b
                    if(!isUsable(current.bgColor.fromB)) current.bgColor.fromB = fromColor.b;
                    if(!isUsable(current.bgColor.totalOffsetB)) current.bgColor.totalOffsetB = (current.bgColor.toB - current.bgColor.fromB);
                    var b = parseInt(current.bgColor.fromB + (current.bgColor.totalOffsetB * progress));

                    // a
                    if(!isUsable(current.bgColor.fromA)) current.bgColor.fromA = fromColor.a;
                    if(!isUsable(current.bgColor.totalOffsetA)) current.bgColor.totalOffsetA = (current.bgColor.toA - current.bgColor.fromA);
                    var a = (current.bgColor.fromA + (current.bgColor.totalOffsetA * progress));

                    //
                    view.setLook({
                        bgColor: "rgba(" + r + ", " + g + ", " + b + ", " + a + ")"
                    });

                }

                // txtColor
                if(current.txtColor) {
                    var fromColor;
                    if(!isUsable(current.txtColor.fromR) || !isUsable(current.txtColor.fromG) || !isUsable(current.txtColor.fromB) || !isUsable(current.txtColor.fromA)) {
                        if(view.look.txtColor) {
                            fromColor = getRGBA(view.look.txtColor);
                        } else {
                            // 若 view 沒設定過 txtColor, 就從透明開始
                            fromColor = {
                                r: current.txtColor.toR,
                                g: current.txtColor.toG,
                                b: current.txtColor.toB,
                                a: 0
                            }
                        }
                    }

                    // r
                    if(!isUsable(current.txtColor.fromR)) current.txtColor.fromR = fromColor.r;
                    if(!isUsable(current.txtColor.totalOffsetR)) current.txtColor.totalOffsetR = (current.txtColor.toR - current.txtColor.fromR);
                    var r = parseInt(current.txtColor.fromR + (current.txtColor.totalOffsetR * progress));

                    // g
                    if(!isUsable(current.txtColor.fromG)) current.txtColor.fromG = fromColor.g;
                    if(!isUsable(current.txtColor.totalOffsetG)) current.txtColor.totalOffsetG = (current.txtColor.toG - current.txtColor.fromG);
                    var g = parseInt(current.txtColor.fromG + (current.txtColor.totalOffsetG * progress));

                    // b
                    if(!isUsable(current.txtColor.fromB)) current.txtColor.fromB = fromColor.b;
                    if(!isUsable(current.txtColor.totalOffsetB)) current.txtColor.totalOffsetB = (current.txtColor.toB - current.txtColor.fromB);
                    var b = parseInt(current.txtColor.fromB + (current.txtColor.totalOffsetB * progress));

                    // a
                    if(!isUsable(current.txtColor.fromA)) current.txtColor.fromA = fromColor.a;
                    if(!isUsable(current.txtColor.totalOffsetA)) current.txtColor.totalOffsetA = (current.txtColor.toA - current.txtColor.fromA);
                    var a = (current.txtColor.fromA + (current.txtColor.totalOffsetA * progress));

                    //
                    view.setLook({
                        txtColor: "rgba(" + r + ", " + g + ", " + b + ", " + a + ")"
                    });

                }

                // boxShadow
                if(current.boxShadow) {
                    // h
                    if(!isUsable(current.boxShadow.toH)) current.boxShadow.toH = view.boxShadow.h; //
                    if(!isUsable(current.boxShadow.fromH)) current.boxShadow.fromH = view.boxShadow.h;
                    if(!isUsable(current.boxShadow.totalOffsetH)) current.boxShadow.totalOffsetH = (current.boxShadow.toH - current.boxShadow.fromH);
                    var h = (current.boxShadow.fromH + (current.boxShadow.totalOffsetH * progress));

                    // v
                    if(!isUsable(current.boxShadow.toV)) current.boxShadow.toV = view.boxShadow.v; //
                    if(!isUsable(current.boxShadow.fromV)) current.boxShadow.fromV = view.boxShadow.v;
                    if(!isUsable(current.boxShadow.totalOffsetV)) current.boxShadow.totalOffsetV = (current.boxShadow.toV - current.boxShadow.fromV);
                    var v = (current.boxShadow.fromV + (current.boxShadow.totalOffsetV * progress));

                    // blur
                    if(!isUsable(current.boxShadow.toBlur)) current.boxShadow.toBlur = view.boxShadow.blur; //
                    if(!isUsable(current.boxShadow.fromBlur)) current.boxShadow.fromBlur = view.boxShadow.blur;
                    if(!isUsable(current.boxShadow.totalOffsetBlur)) current.boxShadow.totalOffsetBlur = (current.boxShadow.toBlur - current.boxShadow.fromBlur);
                    var blur = (current.boxShadow.fromBlur + (current.boxShadow.totalOffsetBlur * progress));

                    // spread
                    if(!isUsable(current.boxShadow.toSpread)) current.boxShadow.toSpread = view.boxShadow.spread; //
                    if(!isUsable(current.boxShadow.fromSpread)) current.boxShadow.fromSpread = view.boxShadow.spread;
                    if(!isUsable(current.boxShadow.totalOffsetSpread)) current.boxShadow.totalOffsetSpread = (current.boxShadow.toSpread - current.boxShadow.fromSpread);
                    var spread = (current.boxShadow.fromSpread + (current.boxShadow.totalOffsetSpread * progress));

                    // color
                    var bsColor;
                    if(current.boxShadow.color) {
                        var fromColor;
                        if(!isUsable(current.boxShadow.color.fromR) || !isUsable(current.boxShadow.color.fromG) || !isUsable(current.boxShadow.color.fromB) || !isUsable(current.boxShadow.color.fromA)) {
                            if(view.boxShadow.color) {
                                fromColor = getRGBA(view.boxShadow.color);
                            } else {
                                // 若 boxShadow 沒設定過 color, 就從透明開始
                                fromColor = {
                                    r: current.boxShadow.color.toR,
                                    g: current.boxShadow.color.toG,
                                    b: current.boxShadow.color.toB,
                                    a: 0
                                }
                            }
                        }

                        // r
                        if(!isUsable(current.boxShadow.color.fromR)) current.boxShadow.color.fromR = fromColor.r;
                        if(!isUsable(current.boxShadow.color.totalOffsetR)) current.boxShadow.color.totalOffsetR = (current.boxShadow.color.toR - current.boxShadow.color.fromR);
                        var r = parseInt(current.boxShadow.color.fromR + (current.boxShadow.color.totalOffsetR * progress));

                        // g
                        if(!isUsable(current.boxShadow.color.fromG)) current.boxShadow.color.fromG = fromColor.g;
                        if(!isUsable(current.boxShadow.color.totalOffsetG)) current.boxShadow.color.totalOffsetG = (current.boxShadow.color.toG - current.boxShadow.color.fromG);
                        var g = parseInt(current.boxShadow.color.fromG + (current.boxShadow.color.totalOffsetG * progress));

                        // b
                        if(!isUsable(current.boxShadow.color.fromB)) current.boxShadow.color.fromB = fromColor.b;
                        if(!isUsable(current.boxShadow.color.totalOffsetB)) current.boxShadow.color.totalOffsetB = (current.boxShadow.color.toB - current.boxShadow.color.fromB);
                        var b = parseInt(current.boxShadow.color.fromB + (current.boxShadow.color.totalOffsetB * progress));

                        // a
                        if(!isUsable(current.boxShadow.color.fromA)) current.boxShadow.color.fromA = fromColor.a;
                        if(!isUsable(current.boxShadow.color.totalOffsetA)) current.boxShadow.color.totalOffsetA = (current.boxShadow.color.toA - current.boxShadow.color.fromA);
                        var a = (current.boxShadow.color.fromA + (current.boxShadow.color.totalOffsetA * progress));

                        //
                        bsColor = "rgba(" + r + ", " + g + ", " + b + ", " + a + ")";

                    } else {
                        bsColor = view.boxShadow.color;
                    }

                    //
                    view.setBoxShadow({
                        visible: true,
                        h: h,
                        v: v,
                        blur: blur,
                        spread: spread,
                        color: bsColor
                    });

                }

                // scroll
                if(current.scroll) {
                    // x
                    if(!isUsable(current.scroll.toX)) current.scroll.toX = view.scroll.x; //
                    if(!isUsable(current.scroll.fromX)) current.scroll.fromX = view.scroll.x;
                    if(!isUsable(current.scroll.totalOffsetX)) current.scroll.totalOffsetX = (current.scroll.toX - current.scroll.fromX);
                    var x = (current.scroll.fromX + (current.scroll.totalOffsetX * progress));

                    // y
                    if(!isUsable(current.scroll.toY)) current.scroll.toY = view.scroll.y; //
                    if(!isUsable(current.scroll.fromY)) current.scroll.fromY = view.scroll.y;
                    if(!isUsable(current.scroll.totalOffsetY)) current.scroll.totalOffsetY = (current.scroll.toY - current.scroll.fromY);
                    var y = (current.scroll.fromY + (current.scroll.totalOffsetY * progress));

                    //
                    view.setScroll({
                        x: x,
                        y: y
                    });

                }

                // core
                _this.emit("frame");

                if(passingTime >= current.duration) {
                    //
                    if(loop) {
                        queue.push(current);
                    }
                    //
                    stop();
                }

                if(run) requestAnimationFrame(animate);

            }

            function stop() {
                // opacity
                if(current.visibility) {
                    if (current.visibility.toValue == 0) {
                        view.core.style.opacity = 0;
                        view.core.style.display = "none";
                        view.opts.visible = false;
                    } else {
                        view.core.style.opacity = current.visibility.toValue;
                        view.core.style.display = "block";
                        view.opts.visible = true;
                    }
                }

                // transform
                if(current.transform) {
                    view.setTransform({
                        translateX: current.transform.toTranslateX,
                        translateY: current.transform.toTranslateY,
                        translateZ: current.transform.toTranslateZ,
                        rotateX: current.transform.toRotateX,
                        rotateY: current.transform.toRotateY,
                        rotateZ: current.transform.toRotateZ,
                        scale: current.transform.toScale,
                        skewX: current.transform.toSkewX,
                        skewY: current.transform.toSkewY
                    });
                }

                // bgColor
                if(current.bgColor) {
                    view.setLook({
                        bgColor: "rgba(" + current.bgColor.toR + ", " + current.bgColor.toG + ", " + current.bgColor.toB + ", " + current.bgColor.toA + ")"
                    });
                }

                // txtColor
                if(current.txtColor) {
                    view.setLook({
                        txtColor: "rgba(" + current.txtColor.toR + ", " + current.txtColor.toG + ", " + current.txtColor.toB + ", " + current.txtColor.toA + ")"
                    });
                }

                // boxShadow
                if(current.boxShadow) {
                    view.setBoxShadow({
                        visible: true,
                        h: current.boxShadow.toH,
                        v: current.boxShadow.toV,
                        blur: current.boxShadow.toBlur,
                        spread: current.boxShadow.toSpread,
                        color: "rgba(" + current.boxShadow.color.toR + ", " + current.boxShadow.color.toG + ", " + current.boxShadow.color.toB + ", " + current.boxShadow.color.toA + ")"
                    });
                }

                // scroll
                if(current.scroll) {
                    view.setScroll({
                        x: current.scroll.toX,
                        y: current.scroll.toY
                    });
                }

                // core
                current = null;
                startTime = null;
                passingTime = null;
                progress = null;

                if(queue.length == 0) {
                    run = false;
                    _this.emit("end");
                }

            }

            function setLoop(lp) {
                loop = lp;
            }

            function isAnimating() {
                return run;
            }

            //
            this.play = play;
            this.stop = stop;
            this.setLoop = setLoop;

            this.isAnimating = isAnimating;

        }

    }


    //
    return Animation;
})();




//
module.exports = Animation;

},{"./EventEmitter":8}],7:[function(require,module,exports){

var EventEmitter = require("./EventEmitter");
var Animation = require("./Animation");

// ====

var CoreView = (function() {
    //

    //
    class CoreView extends EventEmitter {
        constructor(elementType, parentView, options) {
            super();

            var DEFAULT_ANIM_DURATION = 500;

            var _this = this;
            this.core = createCore(elementType);
            this.parentView = parentView;
            this.options = options;

            //
            this.childViews = [];
            this.parentView.addChildView(this);

            //
            this.core.style.position = "absolute";
            this.core.style.display = "block";
            this.core.style.opacity = 1;
            this.core.style.backgroundRepeat = "no-repeat";
            this.core.style.backgroundPosition = "center";
            this.core.style.webkitTapHighlightColor = "rgba(0, 0, 0, 0)"; // 移除 touch 造成的 highlight
            this.core.style.outline = "none"; // 移除 focus/active 時自動出現的框
            this.core.style.boxSizing = "border-box"; // ref http://www.w3schools.com/jsref/prop_style_boxsizing.asp

            //
            function createCore(elementType) {
                var type;
                switch (elementType.toLowerCase()) {
                    case "text":
                        type = elementType;
                        elementType = "input";
                        break;

                    case "file":
                        type = elementType;
                        elementType = "input";
                        break;

                }

                var core = document.createElement(elementType);
                if(type) core.setAttribute("type", type);

                return core;
            }


            // == hierarchy ==
            this.addChildView = function(view) {
                _this.core.appendChild(view.core);
                _this.childViews.push(view);
                // _this.redraw();
            }
            this.removeChildView = function (view) {
                _this.core.removeChild(view.core);
                var idx = _this.childViews.indexOf(view);
                if(idx > -1) _this.childViews.splice(idx, 1);
                // _this.redrawChildViews();
            }
            this.redrawChildViews = function() {
                for(var i=0; i<_this.childViews.length; i++) {
                    if(_this.childViews[i].redraw) _this.childViews[i].redraw(true);
                }
            }


            // == ... ==
            this.setClassName = function(className) {
                _this.core.className = className;
            }


            // == events ==
            this.domOn = function (type, listener, consumeEvent) {
                var consumeEvent = (isUsable(consumeEvent)) ? consumeEvent : true;

                //
                _this.core.addEventListener(type, function(event) {
                    if(event) {
                        if(consumeEvent) {
                            event.preventDefault();
                            event.stopPropagation();
                        }

                        if(listener) {
                            listener(event);
                        } else {
                            // console.warn("no listener");
                        }

                    }
                }, false);

                //
                if(type == "click") {
                    // NOTE for touch control
                    var target = null;
                    _this.core.addEventListener("touchstart", function (event) {
                        // console.log("[start]", event);
                        target = event.target;
                    }, false);
                    _this.core.addEventListener("touchmove", function (event) {
                        // console.log("[move]", event);
                        target = null;
                    }, false);
                    _this.core.addEventListener("touchend", function (event) {
                        // console.log("[end]", event);

                        var endTarget = document.elementFromPoint(
                            event.changedTouches[0].pageX,
                            event.changedTouches[0].pageY
                        );
                        // console.log("[end]", endTarget);

                        //====
                        if(target === endTarget) {
                            if (event) {
                                if (consumeEvent) {
                                    event.preventDefault();
                                    event.stopPropagation();
                                }

                                if (listener) {
                                    listener(event);
                                } else {
                                    console.warn("no listener");
                                }

                            }
                        }

                    }, false);

                    //
                    _this.core.style.cursor = "pointer";
                }

            }


            // == animation ==
            this.anim = new Animation(this);
            // this.anim.on("frame", function() {
            //     console.log("frame");
            // });
            this.anim.on("end", function() {
                _this.emit("anim_end");
            });


            // == set options ==
            this.init();
            this.setOptions(options);
            this.redraw();

            // NOTE example:1
            // NOTE 但仍有點奇怪的是, 上面的那個 redraw 沒有辦法觸發這個 on
            // this.on("redraw", function() {
            //     console.log("[core][on]");
            // });

        }


        //
        // ex() {
        //     super.ex.apply(this, arguments);
        // }

        // == init ==
        init() {
            this.rect = {
                x: 0,
                y: 0,
                w: 100,
                h: 100,
                mode: "%"
            };
            this.look = {
                bgSize: null,           // default 100% 100%
                bgImage: null,
                bgColor: null,
                borderRadius: 0,
                padding: 0              // NOTE padding 是用 [boxSizing = "border-box"] 的 border 模擬的
            };
            this.opts = {
                cursor: "default",
                disabled: false,
                visible: true,
                position: "absolute",   // absolute, fixed
                zIndex: 0,
                userSelect: "none"      // none, text
            };
            this.transform = {
                translateX: 0,
                translateY: 0,
                translateZ: 0,
                rotateX: 0,
                rotateY: 0,
                rotateZ: 0,
                scale: 1,
                skewX: 0,
                skewY: 0
            };
            this.boxShadow = {
                visible: false,
                h: 0,
                v: 0,
                blur: 10,
                spread: 2,
                color: "",
                inset: false
            };
        }
        setOptions(options, setOnly) {
            var _setOnly = (isUsable(setOnly) ? setOnly : false);
            //
            if(isUsable(options)) {
                // NOTE 底下各設定都不 redraw, 後面才一次呼叫 this.redraw()
                if(isUsable(options.rect)) this.setRect(options.rect, _setOnly);
                if(isUsable(options.look)) this.setLook(options.look, _setOnly);
                if(isUsable(options.opts)) this.setOpts(options.opts, _setOnly);
                if(isUsable(options.transform)) this.setTransform(options.transform, _setOnly);
                if(isUsable(options.boxShadow)) this.setBoxShadow(options.boxShadow, _setOnly);
            }
        }

        // == redraw ==

        // rect
        setRect(rect, setOnly) {
            assignToTargetOwnProps(rect, this.rect);
            if(!(isUsable(setOnly) && setOnly)) this.redrawRect();
        }
        redrawRect() {
            // NOTE 實驗中
            if(typeof(this.rect.x) === "string") {
                this.core.style.left = this.rect.x;
            } else {
                this.core.style.left = this.rect.x + this.rect.mode;
            }
            if(typeof(this.rect.y) === "string") {
                this.core.style.top = this.rect.y;
            } else {
                this.core.style.top = this.rect.y + this.rect.mode;
            }
            if(typeof(this.rect.w) === "string") {
                this.core.style.width = this.rect.w;
            } else {
                this.core.style.width = this.rect.w + this.rect.mode;
            }
            if(typeof(this.rect.h) === "string") {
                this.core.style.height = this.rect.h;
            } else {
                this.core.style.height = this.rect.h + this.rect.mode;
            }
            // this.core.style.left = this.rect.x + this.rect.mode;
            // this.core.style.top = this.rect.y + this.rect.mode;
            // this.core.style.width = this.rect.w + this.rect.mode;
            // this.core.style.height = this.rect.h + this.rect.mode;
        }

        // look
        setLook(look, setOnly) {
            assignToTargetOwnProps(look, this.look);
            if(!(isUsable(setOnly) && setOnly)) this.redrawLook();
        }
        redrawLook() {
            // bgImage
            if(this.look.bgSize) {
                this.core.style.backgroundSize = this.look.bgSize + "px";
            } else {
                this.core.style.backgroundSize = "100% 100%";
            }
            this.core.style.backgroundImage = this.look.bgImage;//

            // bgColor
            this.core.style.backgroundColor = this.look.bgColor;

            // borderRadius
            this.core.style.borderRadius = this.look.borderRadius + "px";

            // sPadding (implemented by border)
            if (this.look.padding) {
                // if(this.parentView.look.bgColor) {
                //     this.core.style.border = this.look.padding + "px solid " + this.parentView.look.bgColor;    // NOTE 顯示出 parentView 的背景色, 模擬本 view 的尺寸縮小 >> NOTE 應該直接透明就好了吧
                // } else {
                    this.core.style.border = this.look.padding + "px solid rgba(0, 0, 0, 0)";
                // }
            } else {
                this.core.style.border = "hidden";
            }

        }

        // opts
        setOpts(opts, setOnly) {
            assignToTargetOwnProps(opts, this.opts);
            if(!(isUsable(setOnly) && setOnly)) this.redrawOpts();
        }
        redrawOpts() {
            var redrawAll = false;
            //
            this.core.style.cursor = this.opts.cursor;
            this.core.style.disabled = this.opts.disabled;
            if(this.opts.visible) {
                if(this.core.style.display == "none") redrawAll = true;  // NOTE 這情況需要重新參考尺寸, 所以必須強制重繪
                this.core.style.opacity = 1;
                this.core.style.display = "block";
            } else {
                this.core.style.opacity = 0;
                this.core.style.display = "none";
            }
            this.core.style.position = this.opts.position;
            this.core.style.zIndex = this.opts.zIndex;
            this.core.style.userSelect = this.opts.userSelect;
            //
            if(redrawAll) this.redraw(true);
        }

        // transform
        setTransform(transform, setOnly) {
            assignToTargetOwnProps(transform, this.transform);
            if(!(isUsable(setOnly) && setOnly)) this.redrawTransfrom();
        }
        resetTransform() {
            this.transform = {
                translateX: 0,
                translateY: 0,
                translateZ: 0,
                rotateX: 0,
                rotateY: 0,
                rotateZ: 0,
                scale: 1,
                skewX: 0,
                skewY: 0
            };
            this.redrawTransfrom();
        }
        redrawTransfrom() {
            var trans = "";

            if(this.transform.translateX != 0) trans += "translateX(" + this.transform.translateX + "px) ";
            if(this.transform.translateY != 0) trans += "translateY(" + this.transform.translateY + "px) ";
            if(this.transform.translateZ != 0) trans += "translateZ(" + this.transform.translateZ + "px) ";
            if(this.transform.rotateX != 0) trans += "rotateX(" + this.transform.rotateX + "deg) ";
            if(this.transform.rotateY != 0) trans += "rotateY(" + this.transform.rotateY + "deg) ";
            if(this.transform.rotateZ != 0) trans += "rotateZ(" + this.transform.rotateZ + "deg) ";
            if(this.transform.scale != 1) trans += "scale(" + this.transform.scale + ") ";
            if(this.transform.skewX != 0) trans += "skewX(" + this.transform.skewX + "deg) ";
            if(this.transform.skewY != 0) trans += "skewY(" + this.transform.skewY + "deg) ";

            this.core.style.transform = trans;

        }

        // boxShadow
        setBoxShadow(boxShadow, setOnly) {
            assignToTargetOwnProps(boxShadow, this.boxShadow);
            if(!(isUsable(setOnly) && setOnly)) this.redrawBoxShadow();
        }
        redrawBoxShadow() {
            var bs = "";
            if (this.boxShadow.visible) {
                bs += this.boxShadow.h + "px ";
                bs += this.boxShadow.v + "px ";
                bs += this.boxShadow.blur + "px ";
                bs += this.boxShadow.spread + "px ";
                bs += this.boxShadow.color;
                if(this.boxShadow.inset) bs += " inset";
            }
            this.core.style.boxShadow = bs;
        }

        //
        redraw(redrawChild) {
            this.redrawRect()
            this.redrawLook();
            this.redrawOpts();
            this.redrawTransfrom();
            this.redrawBoxShadow();
            this.emit("redraw");
            // console.log("[redraw][core]", redrawChild);

            // NOTE 關於這個 emit
            // 此 class 的 instance 宣告的 on, 只有該 instance 呼叫的 redraw (裡面的 emit) 會觸發
            // 當 redraw 在此 class 的 constructor 呼叫時, 只有宣告在 constructor 裡面的 on 會觸發 (參照上面的 example:1)


            // ====
            if(isUsable(redrawChild) && redrawChild == true) this.redrawChildViews();

        }


        // == animation ==
        animate(anim) {
            this.anim.play(anim);
        }
        setAnimaionLoop(loop) {
            this.anim.setLoop(loop);
        }


        // == getter ==

        // NOTE 為了在 .style.display == "none" 時還能取到值, 做了以下 workaround
        // TODO 確認在實際製作介面時會否有問題, 尤其時效能低的裝置上

        get PxX() {
            // return this.core.offsetLeft;
            if(this.core.style.display == "block") {
                return this.core.offsetLeft;
            } else {
                this.core.style.display = "block";
                var ret = this.core.offsetLeft;
                this.core.style.display = "none";
                return ret;
            }
        }
        get PxY() {
            // return this.core.offsetTop;
            if(this.core.style.display == "block") {
                return this.core.offsetTop;
            } else {
                this.core.style.display = "block";
                var ret = this.core.offsetTop;
                this.core.style.display = "none";
                return ret;
            }
        }
        get PxW() {
            // return this.core.offsetWidth;
            if(this.core.style.display == "block") {
                return this.core.offsetWidth;
            } else {
                this.core.style.display = "block";
                var ret = this.core.offsetWidth;
                this.core.style.display = "none";
                return ret;
            }
        }
        get PxH() {
            // return this.core.offsetHeight;
            if(this.core.style.display == "block") {
                return this.core.offsetHeight;
            } else {
                this.core.style.display = "block";
                var ret = this.core.offsetHeight;
                this.core.style.display = "none";
                return ret;
            }
        }
        get RectPx() {
            // return {
            //     x: this.PxX,
            //     y: this.PxY,
            //     w: this.PxW,
            //     h: this.PxH
            // };
            if(this.core.style.display == "block") {
                return {
                    x: this.core.offsetLeft,
                    y: this.core.offsetTop,
                    w: this.core.offsetWidth,
                    h: this.core.offsetHeight
                };
            } else {
                this.core.style.display = "block";
                var ret = {
                    x: this.core.offsetLeft,
                    y: this.core.offsetTop,
                    w: this.core.offsetWidth,
                    h: this.core.offsetHeight
                };
                this.core.style.display = "none";
                return ret;
            }
        }

        get ScrollTop() {
            return this.core.scrollTop;
        }
        set ScrollTop(scrollTop) {
            this.core.scrollTop = scrollTop;
        }
        get ScrollLeft() {
            return this.core.scrollLeft;
        }
        set ScrollLeft(scrollLeft) {
            this.core.scrollLeft = scrollLeft;
        }


        // ====
        removeFromParent() {
            if(this.core.parentNode) {
                this.core.parentNode.removeChild(this.core);
            }
        }


    }


    //
    return CoreView
})();


//
module.exports = CoreView;

},{"./Animation":6,"./EventEmitter":8}],8:[function(require,module,exports){
/*!
 * EventEmitter v5.2.2 - git.io/ee
 * Unlicense - http://unlicense.org/
 * Oliver Caldwell - http://oli.me.uk/
 * @preserve
 */

;(function (exports) {
    'use strict';

    /**
     * Class for managing events.
     * Can be extended to provide event functionality in other classes.
     *
     * @class EventEmitter Manages event registering and emitting.
     */
    function EventEmitter() {}

    // Shortcuts to improve speed and size
    var proto = EventEmitter.prototype;
    var originalGlobalValue = exports.EventEmitter;

    /**
     * Finds the index of the listener for the event in its storage array.
     *
     * @param {Function[]} listeners Array of listeners to search through.
     * @param {Function} listener Method to look for.
     * @return {Number} Index of the specified listener, -1 if not found
     * @api private
     */
    function indexOfListener(listeners, listener) {
        var i = listeners.length;
        while (i--) {
            if (listeners[i].listener === listener) {
                return i;
            }
        }

        return -1;
    }

    /**
     * Alias a method while keeping the context correct, to allow for overwriting of target method.
     *
     * @param {String} name The name of the target method.
     * @return {Function} The aliased method
     * @api private
     */
    function alias(name) {
        return function aliasClosure() {
            return this[name].apply(this, arguments);
        };
    }

    /**
     * Returns the listener array for the specified event.
     * Will initialise the event object and listener arrays if required.
     * Will return an object if you use a regex search. The object contains keys for each matched event. So /ba[rz]/ might return an object containing bar and baz. But only if you have either defined them with defineEvent or added some listeners to them.
     * Each property in the object response is an array of listener functions.
     *
     * @param {String|RegExp} evt Name of the event to return the listeners from.
     * @return {Function[]|Object} All listener functions for the event.
     */
    proto.getListeners = function getListeners(evt) {
        var events = this._getEvents();
        var response;
        var key;

        // Return a concatenated array of all matching events if
        // the selector is a regular expression.
        if (evt instanceof RegExp) {
            response = {};
            for (key in events) {
                if (events.hasOwnProperty(key) && evt.test(key)) {
                    response[key] = events[key];
                }
            }
        }
        else {
            response = events[evt] || (events[evt] = []);
        }

        return response;
    };

    /**
     * Takes a list of listener objects and flattens it into a list of listener functions.
     *
     * @param {Object[]} listeners Raw listener objects.
     * @return {Function[]} Just the listener functions.
     */
    proto.flattenListeners = function flattenListeners(listeners) {
        var flatListeners = [];
        var i;

        for (i = 0; i < listeners.length; i += 1) {
            flatListeners.push(listeners[i].listener);
        }

        return flatListeners;
    };

    /**
     * Fetches the requested listeners via getListeners but will always return the results inside an object. This is mainly for internal use but others may find it useful.
     *
     * @param {String|RegExp} evt Name of the event to return the listeners from.
     * @return {Object} All listener functions for an event in an object.
     */
    proto.getListenersAsObject = function getListenersAsObject(evt) {
        var listeners = this.getListeners(evt);
        var response;

        if (listeners instanceof Array) {
            response = {};
            response[evt] = listeners;
        }

        return response || listeners;
    };

    function isValidListener (listener) {
        if (typeof listener === 'function' || listener instanceof RegExp) {
            return true
        } else if (listener && typeof listener === 'object') {
            return isValidListener(listener.listener)
        } else {
            return false
        }
    }

    /**
     * Adds a listener function to the specified event.
     * The listener will not be added if it is a duplicate.
     * If the listener returns true then it will be removed after it is called.
     * If you pass a regular expression as the event name then the listener will be added to all events that match it.
     *
     * @param {String|RegExp} evt Name of the event to attach the listener to.
     * @param {Function} listener Method to be called when the event is emitted. If the function returns true then it will be removed after calling.
     * @return {Object} Current instance of EventEmitter for chaining.
     */
    proto.addListener = function addListener(evt, listener) {
        if (!isValidListener(listener)) {
            throw new TypeError('listener must be a function');
        }

        var listeners = this.getListenersAsObject(evt);
        var listenerIsWrapped = typeof listener === 'object';
        var key;

        for (key in listeners) {
            if (listeners.hasOwnProperty(key) && indexOfListener(listeners[key], listener) === -1) {
                listeners[key].push(listenerIsWrapped ? listener : {
                    listener: listener,
                    once: false
                });
            }
        }

        return this;
    };

    /**
     * Alias of addListener
     */
    proto.on = alias('addListener');

    /**
     * Semi-alias of addListener. It will add a listener that will be
     * automatically removed after its first execution.
     *
     * @param {String|RegExp} evt Name of the event to attach the listener to.
     * @param {Function} listener Method to be called when the event is emitted. If the function returns true then it will be removed after calling.
     * @return {Object} Current instance of EventEmitter for chaining.
     */
    proto.addOnceListener = function addOnceListener(evt, listener) {
        return this.addListener(evt, {
            listener: listener,
            once: true
        });
    };

    /**
     * Alias of addOnceListener.
     */
    proto.once = alias('addOnceListener');

    /**
     * Defines an event name. This is required if you want to use a regex to add a listener to multiple events at once. If you don't do this then how do you expect it to know what event to add to? Should it just add to every possible match for a regex? No. That is scary and bad.
     * You need to tell it what event names should be matched by a regex.
     *
     * @param {String} evt Name of the event to create.
     * @return {Object} Current instance of EventEmitter for chaining.
     */
    proto.defineEvent = function defineEvent(evt) {
        this.getListeners(evt);
        return this;
    };

    /**
     * Uses defineEvent to define multiple events.
     *
     * @param {String[]} evts An array of event names to define.
     * @return {Object} Current instance of EventEmitter for chaining.
     */
    proto.defineEvents = function defineEvents(evts) {
        for (var i = 0; i < evts.length; i += 1) {
            this.defineEvent(evts[i]);
        }
        return this;
    };

    /**
     * Removes a listener function from the specified event.
     * When passed a regular expression as the event name, it will remove the listener from all events that match it.
     *
     * @param {String|RegExp} evt Name of the event to remove the listener from.
     * @param {Function} listener Method to remove from the event.
     * @return {Object} Current instance of EventEmitter for chaining.
     */
    proto.removeListener = function removeListener(evt, listener) {
        var listeners = this.getListenersAsObject(evt);
        var index;
        var key;

        for (key in listeners) {
            if (listeners.hasOwnProperty(key)) {
                index = indexOfListener(listeners[key], listener);

                if (index !== -1) {
                    listeners[key].splice(index, 1);
                }
            }
        }

        return this;
    };

    /**
     * Alias of removeListener
     */
    proto.off = alias('removeListener');

    /**
     * Adds listeners in bulk using the manipulateListeners method.
     * If you pass an object as the first argument you can add to multiple events at once. The object should contain key value pairs of events and listeners or listener arrays. You can also pass it an event name and an array of listeners to be added.
     * You can also pass it a regular expression to add the array of listeners to all events that match it.
     * Yeah, this function does quite a bit. That's probably a bad thing.
     *
     * @param {String|Object|RegExp} evt An event name if you will pass an array of listeners next. An object if you wish to add to multiple events at once.
     * @param {Function[]} [listeners] An optional array of listener functions to add.
     * @return {Object} Current instance of EventEmitter for chaining.
     */
    proto.addListeners = function addListeners(evt, listeners) {
        // Pass through to manipulateListeners
        return this.manipulateListeners(false, evt, listeners);
    };

    /**
     * Removes listeners in bulk using the manipulateListeners method.
     * If you pass an object as the first argument you can remove from multiple events at once. The object should contain key value pairs of events and listeners or listener arrays.
     * You can also pass it an event name and an array of listeners to be removed.
     * You can also pass it a regular expression to remove the listeners from all events that match it.
     *
     * @param {String|Object|RegExp} evt An event name if you will pass an array of listeners next. An object if you wish to remove from multiple events at once.
     * @param {Function[]} [listeners] An optional array of listener functions to remove.
     * @return {Object} Current instance of EventEmitter for chaining.
     */
    proto.removeListeners = function removeListeners(evt, listeners) {
        // Pass through to manipulateListeners
        return this.manipulateListeners(true, evt, listeners);
    };

    /**
     * Edits listeners in bulk. The addListeners and removeListeners methods both use this to do their job. You should really use those instead, this is a little lower level.
     * The first argument will determine if the listeners are removed (true) or added (false).
     * If you pass an object as the second argument you can add/remove from multiple events at once. The object should contain key value pairs of events and listeners or listener arrays.
     * You can also pass it an event name and an array of listeners to be added/removed.
     * You can also pass it a regular expression to manipulate the listeners of all events that match it.
     *
     * @param {Boolean} remove True if you want to remove listeners, false if you want to add.
     * @param {String|Object|RegExp} evt An event name if you will pass an array of listeners next. An object if you wish to add/remove from multiple events at once.
     * @param {Function[]} [listeners] An optional array of listener functions to add/remove.
     * @return {Object} Current instance of EventEmitter for chaining.
     */
    proto.manipulateListeners = function manipulateListeners(remove, evt, listeners) {
        var i;
        var value;
        var single = remove ? this.removeListener : this.addListener;
        var multiple = remove ? this.removeListeners : this.addListeners;

        // If evt is an object then pass each of its properties to this method
        if (typeof evt === 'object' && !(evt instanceof RegExp)) {
            for (i in evt) {
                if (evt.hasOwnProperty(i) && (value = evt[i])) {
                    // Pass the single listener straight through to the singular method
                    if (typeof value === 'function') {
                        single.call(this, i, value);
                    }
                    else {
                        // Otherwise pass back to the multiple function
                        multiple.call(this, i, value);
                    }
                }
            }
        }
        else {
            // So evt must be a string
            // And listeners must be an array of listeners
            // Loop over it and pass each one to the multiple method
            i = listeners.length;
            while (i--) {
                single.call(this, evt, listeners[i]);
            }
        }

        return this;
    };

    /**
     * Removes all listeners from a specified event.
     * If you do not specify an event then all listeners will be removed.
     * That means every event will be emptied.
     * You can also pass a regex to remove all events that match it.
     *
     * @param {String|RegExp} [evt] Optional name of the event to remove all listeners for. Will remove from every event if not passed.
     * @return {Object} Current instance of EventEmitter for chaining.
     */
    proto.removeEvent = function removeEvent(evt) {
        var type = typeof evt;
        var events = this._getEvents();
        var key;

        // Remove different things depending on the state of evt
        if (type === 'string') {
            // Remove all listeners for the specified event
            delete events[evt];
        }
        else if (evt instanceof RegExp) {
            // Remove all events matching the regex.
            for (key in events) {
                if (events.hasOwnProperty(key) && evt.test(key)) {
                    delete events[key];
                }
            }
        }
        else {
            // Remove all listeners in all events
            delete this._events;
        }

        return this;
    };

    /**
     * Alias of removeEvent.
     *
     * Added to mirror the node API.
     */
    proto.removeAllListeners = alias('removeEvent');

    /**
     * Emits an event of your choice.
     * When emitted, every listener attached to that event will be executed.
     * If you pass the optional argument array then those arguments will be passed to every listener upon execution.
     * Because it uses `apply`, your array of arguments will be passed as if you wrote them out separately.
     * So they will not arrive within the array on the other side, they will be separate.
     * You can also pass a regular expression to emit to all events that match it.
     *
     * @param {String|RegExp} evt Name of the event to emit and execute listeners for.
     * @param {Array} [args] Optional array of arguments to be passed to each listener.
     * @return {Object} Current instance of EventEmitter for chaining.
     */
    proto.emitEvent = function emitEvent(evt, args) {
        var listenersMap = this.getListenersAsObject(evt);
        var listeners;
        var listener;
        var i;
        var key;
        var response;

        for (key in listenersMap) {
            if (listenersMap.hasOwnProperty(key)) {
                listeners = listenersMap[key].slice(0);

                for (i = 0; i < listeners.length; i++) {
                    // If the listener returns true then it shall be removed from the event
                    // The function is executed either with a basic call or an apply if there is an args array
                    listener = listeners[i];

                    if (listener.once === true) {
                        this.removeListener(evt, listener.listener);
                    }

                    response = listener.listener.apply(this, args || []);

                    if (response === this._getOnceReturnValue()) {
                        this.removeListener(evt, listener.listener);
                    }
                }
            }
        }

        return this;
    };

    /**
     * Alias of emitEvent
     */
    proto.trigger = alias('emitEvent');

    /**
     * Subtly different from emitEvent in that it will pass its arguments on to the listeners, as opposed to taking a single array of arguments to pass on.
     * As with emitEvent, you can pass a regex in place of the event name to emit to all events that match it.
     *
     * @param {String|RegExp} evt Name of the event to emit and execute listeners for.
     * @param {...*} Optional additional arguments to be passed to each listener.
     * @return {Object} Current instance of EventEmitter for chaining.
     */
    proto.emit = function emit(evt) {
        var args = Array.prototype.slice.call(arguments, 1);
        return this.emitEvent(evt, args);
    };

    /**
     * Sets the current value to check against when executing listeners. If a
     * listeners return value matches the one set here then it will be removed
     * after execution. This value defaults to true.
     *
     * @param {*} value The new value to check for when executing listeners.
     * @return {Object} Current instance of EventEmitter for chaining.
     */
    proto.setOnceReturnValue = function setOnceReturnValue(value) {
        this._onceReturnValue = value;
        return this;
    };

    /**
     * Fetches the current value to check against when executing listeners. If
     * the listeners return value matches this one then it should be removed
     * automatically. It will return true by default.
     *
     * @return {*|Boolean} The current value to check for or the default, true.
     * @api private
     */
    proto._getOnceReturnValue = function _getOnceReturnValue() {
        if (this.hasOwnProperty('_onceReturnValue')) {
            return this._onceReturnValue;
        }
        else {
            return true;
        }
    };

    /**
     * Fetches the events object and creates one if required.
     *
     * @return {Object} The events storage object.
     * @api private
     */
    proto._getEvents = function _getEvents() {
        return this._events || (this._events = {});
    };

    /**
     * Reverts the global {@link EventEmitter} to its previous value and returns a reference to this version.
     *
     * @return {Function} Non conflicting EventEmitter class.
     */
    EventEmitter.noConflict = function noConflict() {
        exports.EventEmitter = originalGlobalValue;
        return EventEmitter;
    };

    // Expose the class either via AMD, CommonJS or the global object
    if (typeof define === 'function' && define.amd) {
        define(function () {
            return EventEmitter;
        });
    }
    else if (typeof module === 'object' && module.exports){
        module.exports = EventEmitter;
    }
    else {
        exports.EventEmitter = EventEmitter;
    }
}(this || {}));

},{}],9:[function(require,module,exports){

var DivView = require("../basic/DivView");

// ====

var BasePanel = (function() {
    //

    //
    class BasePanel extends DivView {
        constructor(parentView, options) {
            super(parentView, options);
            var _this = this;

        }

        // ====

        show() {
            // this.animate({
            //     visibility: 1,
            //     duration: 250
            // });
            this.setOpts({ visible: true });

            // // NOTE 似乎有情況必須要這樣才能正常顯示 TODO 確認 >> 移除測試中
            // this.redraw(true);
        }
        hide() {
            this.animate({
                visibility: 0,
                duration: 250
            });
        }

        slideInFromLeft() {
            this.animate([{
                visibility: 0,
                transform: {
                    translateX: -(this.PxX + this.PxW)
                },
                duration: 0
            }, {
                visibility: 1,
                transform: {
                    translateX: 0
                },
                // duration: 1000
            }]);
        }
        slideInFromRight() {
            this.animate([{
                visibility: 0,
                transform: {
                    translateX: document.documentElement.offsetWidth + this.PxW
                },
                duration: 0
            }, {
                visibility: 1,
                transform: {
                    translateX: 0
                },
                // duration: 1000
            }]);
        }
        slideInFromTop() {
            this.animate([{
                visibility: 0,
                transform: {
                    translateY: -(this.PxY + this.PxH)
                },
                duration: 0
            }, {
                visibility: 1,
                transform: {
                    translateY: 0
                },
                // duration: 1000
            }]);
        }
        slideInFromBottom() {
            this.animate([{
                visibility: 0,
                transform: {
                    translateY: document.documentElement.offsetHeight + this.PxH
                },
                duration: 0
            }, {
                visibility: 1,
                transform: {
                    translateY: 0
                },
                // duration: 1000
            }]);
        }

        slideOutToLeft() {
            this.animate([{
                transform: {
                    translateX: 0
                },
                duration: 0
            }, {
                visibility: 0,
                transform: {
                    translateX: -(this.PxX + this.PxW)
                },
                // duration: 1000
            }]);
        }
        slideOutToRight() {
            this.animate([{
                transform: {
                    translateX: 0
                },
                duration: 0
            }, {
                visibility: 0,
                transform: {
                    translateX: document.documentElement.offsetWidth + this.PxW
                },
                // duration: 1000
            }]);
        }
        slideOutToTop() {
            this.animate([{
                transform: {
                    translateY: 0
                },
                duration: 0
            }, {
                visibility: 0,
                transform: {
                    translateY: -(this.PxY + this.PxH)
                },
                // duration: 1000
            }]);
        }
        slideOutToBottom() {
            this.animate([{
                transform: {
                    translateY: 0
                },
                duration: 0
            }, {
                visibility: 0,
                transform: {
                    translateY: document.documentElement.offsetHeight + this.PxH
                },
                // duration: 1000
            }]);
        }

        dispose() {
            this.hide();
            this.removeFromParent();
        }

    }


    //
    return BasePanel;
})();


//
module.exports = BasePanel;

},{"../basic/DivView":2}],10:[function(require,module,exports){

var ButtonView = require("../basic/ButtonView");
var ToggleView = require("../basic/ToggleView");
var TextView = require("../basic/TextView");
var BasePanel = require("./BasePanel");
var ListPanel = require("./ListPanel");
var ListItem = require("./ListItem");

// ====

// NOTE TODO 新參數寫在 init 裡, 新參數造成的改變寫在 constructor 裡.

var COLOR_BTN_BRIGHT = "rgb(56, 147, 170)";

var MonthSelector = (function() {
    //
    class ControlPanel extends BasePanel {
        constructor(parentView, options) {
            super(parentView, options);
            var _this = this;

            this.year;


            // == methods ==
            function setYear(year) {
                _this.year = year;
                _this.btnYear.setLook({ txt: year + " 年" });
            }
            //
            this.setYear = setYear;


            // == events ==
            this.btnYear.on("click", function() {
                _this.emit("yearClicked");
            });
            this.btnUp.on("click", function() {
                _this.year--;
                setYear(_this.year);
                _this.emit("yearChanged", _this.year);
            });
            this.btnDown.on("click", function() {
                _this.year++;
                setYear(_this.year);
                _this.emit("yearChanged", _this.year);
            });


        }


        // == init ==
        init() {
            super.init();

            // look
            this.look.bgColor = COLOR_BTN_BRIGHT;
            //
            this.look.btnBgColor = COLOR_BTN_BRIGHT;
            this.look.btnTxtColor = "rgb(240, 240, 240)";
            this.look.btnTxtColor_down = "rgb(200, 200, 200)";

            //
            // == ui ==
            var UNIT_W = 100 / 10;

            var cellYear = new BasePanel(this, {
                rect: { x: UNIT_W * 0, w: UNIT_W * 6 }
            });
            var btnYear = new ButtonView(cellYear, {
                look: {
                    txtScale: 0.4,
                    bgNormal: this.look.btnBgColor,
                    bgEnter: this.look.btnBgColor,
                    bgDown: this.look.btnBgColor,
                    txtNormal: this.look.btnTxtColor,
                    txtEnter: this.look.btnTxtColor,
                    txtDown: this.look.btnTxtColor_down
                }
            });

            var cellUp = new BasePanel(this, {
                rect: { x: UNIT_W * 6, w: UNIT_W * 2 },
                look: { bgColor: this.look.btnBgNormal }
            });
            var btnUp = new ButtonView(cellUp, {
                look: {
                    bgNormal: this.look.btnBgColor,
                    bgEnter: this.look.btnBgColor,
                    bgDown: this.look.btnBgColor,
                    imgNormal: "url('img/sys/up_white.png')",
                    imgEnter: "url('img/sys/up_white.png')",
                    imgDown: "url('img/sys/up_light_gray.png')"
                }
            });

            var cellDown = new BasePanel(this, {
                rect: { x: UNIT_W * 8, w: UNIT_W * 2 },
                look: { bgColor: this.look.btnBgNormal }
            });
            var btnDown = new ButtonView(cellDown, {
                look: {
                    bgNormal: this.look.btnBgColor,
                    bgEnter: this.look.btnBgColor,
                    bgDown: this.look.btnBgColor,
                    imgNormal: "url('img/sys/down_white.png')",
                    imgEnter: "url('img/sys/down_white.png')",
                    imgDown: "url('img/sys/down_light_gray.png')"
                }
            });


            //
            this.cellUp = cellUp;

            this.btnYear = btnYear;
            this.btnUp = btnUp;
            this.btnDown = btnDown;

        }

        //
        redrawRect() {
            super.redrawRect();

            var refRect = this.cellUp.RectPx;
            var refSize = ((refRect.w > refRect.h) ? refRect.h : refRect.w) * 0.8;

            this.btnUp.setRect({
                x: (refRect.w - refSize) / 2,
                y: (refRect.h - refSize) / 2,
                h: refSize,
                w: refSize,
                mode: "px"
            });

            this.btnDown.setRect({
                x: (refRect.w - refSize) / 2,
                y: (refRect.h - refSize) / 2,
                h: refSize,
                w: refSize,
                mode: "px"
            });

        }


    }

    //
    class MonthPanel extends BasePanel {
        constructor(parentView, options) {
            super(parentView, options);
            var _this = this;


            // == methods ==


            // == events ==
            // this.btnYear.on("click", function() {
            //     _this.emit("yearMonthClicked");
            // });
            for(var i=0; i<12; i++) {
                (function(I) {

                    _this.btns[I].on("click", function() {
                        _this.emit("monthClicked", I);
                    });

                })(i);
            }

        }


        // == init ==
        init() {
            super.init();

            // look
            this.look.bgColor = "rgb(150, 150, 150)";
            //
            this.look.btnBgColor = COLOR_BTN_BRIGHT;
            this.look.btnTxtColor = "rgb(240, 240, 240)";
            this.look.btnTxtColor_down = "rgb(200, 200, 200)";

            //
            // == ui ==
            var UNIT_W = 100 / 4;
            var UNIT_H = 100 / 3;
            var cell, btn;
            // this.cells = [];
            this.btns = [];

            for(var i=0; i<12; i++) {
                cell = new BasePanel(this, {
                    rect: {
                        x: UNIT_W * (i % 4),
                        y: UNIT_H * (Math.floor(i / 4)),
                        w: UNIT_W,
                        h: UNIT_H
                    }
                });
                btn = new ButtonView(cell, {
                    look: {
                        txtScale: 0.2,
                        bgNormal: this.look.btnBgColor,
                        bgEnter: this.look.btnBgColor,
                        bgDown: this.look.btnBgColor,
                        txtNormal: this.look.btnTxtColor,
                        txtEnter: this.look.btnTxtColor,
                        txtDown: this.look.btnTxtColor_down,
                        txt: (i+1) + "月"
                    }
                });
                this.btns.push(btn);
            }



            //
            // this.btnYear = btnYear;

        }


    }


    //
    class MonthSelector extends BasePanel {
        constructor(parentView, options) {
            super(parentView, options);
            var _this = this;

            var yearSelector;


            // == methods ==
            function initYearSelector() {
                yearSelector = new YearSelector(_this);
                yearSelector.on("yearSelected", function(year) {
                    _this.year = year;
                    _this.controlPanel.setYear(year);
                    yearSelector.hide();
                });

            }
            function showYearSelector() {
                if(!yearSelector) initYearSelector();
                yearSelector.show(_this.year);
            }


            // == events ==
            this.controlPanel.on("yearClicked", function() {
                showYearSelector();
            });
            this.controlPanel.on("yearChanged", function(year) {
                _this.year = year;
            });
            this.monthPanel.on("monthClicked", function(month) {
                _this.month = month;
                _this.emit("monthSelected", _this.year, _this.month);
            });

        }


        // == init ==
        init() {
            super.init();

            var now = new Date();
            this.year = now.getFullYear();
            this.month = now.getMonth();

            //
            var _this = this;
            var MASK_COLOR = "rgba(50, 50, 50, 0.7)";

            // look
            this.look.bgColor = MASK_COLOR;//"rgba(200, 200, 200, 0.7)";
            //
            this.look.txtBack = "Back";
            this.look.txtDone = "Done";
            this.look.panelBgColor = "rgb(150, 150, 150)";
            this.look.panelTxtColor = "rgb(255, 255, 255)";
            this.look.panelSubTxtColor = "rgb(180, 180, 180)";
            this.look.btnBgColorEnter = "rgb(150, 150, 150)";
            this.look.btnTxtColorEnter = "rgb(255, 255, 255)";
            this.look.btnBgColorDown = "rgb(200, 200, 200)";
            this.look.btnTxtColorDown = "rgb(80, 80, 80)";

            // opts
            this.opts.visible = false;

            //
            // == ui ==
            var UNIT_H = 100 / 7.5;

            var controlPanel = new ControlPanel(this, {
                rect: { y: UNIT_H * 0, h: UNIT_H * 1 }
            });

            var monthPanel = new MonthPanel(this, {
                rect: { y: UNIT_H * 1, h: UNIT_H * 6.5 }
            });


            //
            this.controlPanel = controlPanel;
            this.monthPanel = monthPanel;

        }


        //
        show(year) {
            super.show();

            this.year = year;
            this.controlPanel.setYear(year);

        }

    }




    // ====
    return MonthSelector;
})();

var YearSelector = (function() {
    //
    class ControlPanel extends BasePanel {
        constructor(parentView, options) {
            super(parentView, options);
            var _this = this;

            this.year;


            // == methods ==


            // == events ==
            // this.btnYear.on("click", function() {
            //     _this.emit("yearClicked");
            // });
            this.btnUp.on("click", function() {
                _this.emit("yearUp");
            });
            this.btnDown.on("click", function() {
                _this.emit("yearDown");
            });


        }


        // == init ==
        init() {
            super.init();

            // look
            this.look.bgColor = COLOR_BTN_BRIGHT;
            //
            this.look.btnBgColor = COLOR_BTN_BRIGHT;


            // == ui ==
            var UNIT_W = 100 / 10;

            var cellUp = new BasePanel(this, {
                rect: { x: UNIT_W * 6, w: UNIT_W * 2 },
                look: { bgColor: this.look.btnBgNormal }
            });
            var btnUp = new ButtonView(cellUp, {
                look: {
                    bgNormal: this.look.btnBgColor,
                    bgEnter: this.look.btnBgColor,
                    bgDown: this.look.btnBgColor,
                    imgNormal: "url('img/sys/up_white.png')",
                    imgEnter: "url('img/sys/up_white.png')",
                    imgDown: "url('img/sys/up_light_gray.png')"
                }
            });

            var cellDown = new BasePanel(this, {
                rect: { x: UNIT_W * 8, w: UNIT_W * 2 },
                look: { bgColor: this.look.btnBgNormal }
            });
            var btnDown = new ButtonView(cellDown, {
                look: {
                    bgNormal: this.look.btnBgColor,
                    bgEnter: this.look.btnBgColor,
                    bgDown: this.look.btnBgColor,
                    imgNormal: "url('img/sys/down_white.png')",
                    imgEnter: "url('img/sys/down_white.png')",
                    imgDown: "url('img/sys/down_light_gray.png')"
                }
            });


            //
            this.cellUp = cellUp;

            this.btnUp = btnUp;
            this.btnDown = btnDown;

        }

        //
        redrawRect() {
            super.redrawRect();

            var refRect = this.cellUp.RectPx;
            var refSize = ((refRect.w > refRect.h) ? refRect.h : refRect.w) * 0.8;

            this.btnUp.setRect({
                x: (refRect.w - refSize) / 2,
                y: (refRect.h - refSize) / 2,
                h: refSize,
                w: refSize,
                mode: "px"
            });

            this.btnDown.setRect({
                x: (refRect.w - refSize) / 2,
                y: (refRect.h - refSize) / 2,
                h: refSize,
                w: refSize,
                mode: "px"
            });

        }


    }

    //
    class YearPanel extends BasePanel {
        constructor(parentView, options) {
            super(parentView, options);
            var _this = this;

            var fromYear;


            // == methods ==
            function setYears(from) {
                fromYear = from - 8;
                for(var i=0; i<12; i++) {
                    _this.btns[i].setLook({ txt: (fromYear + i) });
                }
            }
            //
            this.setYears = setYears;


            // == events ==
            for(var i=0; i<12; i++) {
                (function(I) {

                    _this.btns[I].on("click", function() {
                        _this.emit("yearClicked", (fromYear + I));
                    });

                })(i);
            }

        }


        // == init ==
        init() {
            super.init();

            // look
            this.look.bgColor = "rgb(150, 150, 150)";
            //
            this.look.btnBgColor = COLOR_BTN_BRIGHT;
            this.look.btnTxtColor = "rgb(240, 240, 240)";
            this.look.btnTxtColor_down = "rgb(200, 200, 200)";

            //
            // == ui ==
            var UNIT_W = 100 / 4;
            var UNIT_H = 100 / 3;
            var cell, btn;
            // this.cells = [];
            this.btns = [];

            for(var i=0; i<12; i++) {
                cell = new BasePanel(this, {
                    rect: {
                        x: UNIT_W * (i % 4),
                        y: UNIT_H * (Math.floor(i / 4)),
                        w: UNIT_W,
                        h: UNIT_H
                    }
                });
                btn = new ButtonView(cell, {
                    look: {
                        txtScale: 0.2,
                        bgNormal: this.look.btnBgColor,
                        bgEnter: this.look.btnBgColor,
                        bgDown: this.look.btnBgColor,
                        txtNormal: this.look.btnTxtColor,
                        txtEnter: this.look.btnTxtColor,
                        txtDown: this.look.btnTxtColor_down,
                        txt: (i+1) + "月"
                    }
                });
                this.btns.push(btn);
            }


        }


    }


    //
    class YearSelector extends BasePanel {
        constructor(parentView, options) {
            super(parentView, options);
            var _this = this;


            // == methods ==


            // == events ==
            // this.controlPanel.on("yearClicked", function() {
            //     console.log("yearClicked");
            // });
            this.controlPanel.on("yearUp", function() {
                _this.year -= 12;
                _this.yearPanel.setYears(_this.year);
            });
            this.controlPanel.on("yearDown", function() {
                _this.year += 12;
                _this.yearPanel.setYears(_this.year);
            });
            this.yearPanel.on("yearClicked", function(year) {
                _this.emit("yearSelected", year);
            });

        }


        // == init ==
        init() {
            super.init();

            var now = new Date();
            this.year = now.getFullYear();
            this.month = now.getMonth();

            //
            var _this = this;
            var MASK_COLOR = "rgba(50, 50, 50, 0.7)";

            // look
            this.look.bgColor = MASK_COLOR;//"rgba(200, 200, 200, 0.7)";
            //
            this.look.txtBack = "Back";
            this.look.txtDone = "Done";
            this.look.panelBgColor = "rgb(150, 150, 150)";
            this.look.panelTxtColor = "rgb(255, 255, 255)";
            this.look.panelSubTxtColor = "rgb(180, 180, 180)";
            this.look.btnBgColorEnter = "rgb(150, 150, 150)";
            this.look.btnTxtColorEnter = "rgb(255, 255, 255)";
            this.look.btnBgColorDown = "rgb(200, 200, 200)";
            this.look.btnTxtColorDown = "rgb(80, 80, 80)";

            // opts
            this.opts.visible = false;

            //
            // == ui ==
            var UNIT_H = 100 / 7.5;

            var controlPanel = new ControlPanel(this, {
                rect: { y: UNIT_H * 0, h: UNIT_H * 1 }
            });

            var yearPanel = new YearPanel(this, {
                rect: { y: UNIT_H * 1, h: UNIT_H * 6.5 }
            });


            //
            this.controlPanel = controlPanel;
            this.yearPanel = yearPanel;

        }


        //
        show(year) {
            super.show();

            this.year = year;
            this.yearPanel.setYears(year);

        }

    }


    // ====
    return YearSelector;
})();

//
var Calendar = (function() {
    //

    //
    class ControlPanel extends BasePanel {
        constructor(parentView, options) {
            super(parentView, options);
            var _this = this;


            // == methods ==
            function setYearMonth(year, month) {
                _this.btnYearMonth.setLook({ txt: year + "年 " + month + "月" });
            }
            //
            this.setYearMonth = setYearMonth;


            // == events ==

            this.btnYearMonth.on("click", function() {
                _this.emit("yearMonthClicked");
            });
            this.btnUp.on("click", function() {
                _this.emit("upClicked");
            });
            this.btnDown.on("click", function() {
                _this.emit("downClicked");
            });

        }


        // == init ==
        init() {
            super.init();

            // look
            this.look.bgColor = "rgb(150, 150, 150)";
            //
            this.look.btnBgNormal = COLOR_BTN_BRIGHT;
            this.look.btnBgEnter = "rgb(200, 200, 200)";
            this.look.btnBgDown = "rgb(100, 100, 100)";
            this.look.btnTxtNormal = "rgb(240, 240, 240)";
            this.look.btnTxtEnter = "rgb(100, 100, 100)";
            this.look.btnTxtDown = "rgb(200, 200, 200)";


            //
            // == ui ==
            var UNIT_W = 100 / 10;

            var cellYearMonth = new BasePanel(this, {
                rect: { x: UNIT_W * 0, w: UNIT_W * 6 }
            });
            var btnYearMonth = new ButtonView(cellYearMonth, {
                look: {
                    txtScale: 0.4,
                    bgNormal: this.look.btnBgNormal,
                    bgEnter: this.look.btnBgNormal,
                    bgDown: this.look.btnBgNormal,
                    txtNormal: this.look.btnTxtNormal,
                    txtEnter: this.look.btnTxtNormal,
                    txtDown: this.look.btnTxtDown
                }
            });

            var cellUp = new BasePanel(this, {
                rect: { x: UNIT_W * 6, w: UNIT_W * 2 },
                look: { bgColor: this.look.btnBgNormal }
            });
            var btnUp = new ButtonView(cellUp, {
                look: {
                    bgNormal: this.look.btnBgNormal,
                    bgEnter: this.look.btnBgNormal,
                    bgDown: this.look.btnBgNormal,
                    imgNormal: "url('img/sys/up_white.png')",
                    imgEnter: "url('img/sys/up_white.png')",
                    imgDown: "url('img/sys/up_light_gray.png')"
                }
            });

            var cellDown = new BasePanel(this, {
                rect: { x: UNIT_W * 8, w: UNIT_W * 2 },
                look: { bgColor: this.look.btnBgNormal }
            });
            var btnDown = new ButtonView(cellDown, {
                look: {
                    bgNormal: this.look.btnBgNormal,
                    bgEnter: this.look.btnBgNormal,
                    bgDown: this.look.btnBgNormal,
                    imgNormal: "url('img/sys/down_white.png')",
                    imgEnter: "url('img/sys/down_white.png')",
                    imgDown: "url('img/sys/down_light_gray.png')"
                }
            });


            //
            this.cellUp = cellUp;

            this.btnYearMonth = btnYearMonth;
            this.btnUp = btnUp;
            this.btnDown = btnDown;

        }

        //
        redrawRect() {
            super.redrawRect();

            var refRect = this.cellUp.RectPx;
            var refSize = ((refRect.w > refRect.h) ? refRect.h : refRect.w) * 0.8;

            this.btnUp.setRect({
                x: (refRect.w - refSize) / 2,
                y: (refRect.h - refSize) / 2,
                h: refSize,
                w: refSize,
                mode: "px"
            });

            this.btnDown.setRect({
                x: (refRect.w - refSize) / 2,
                y: (refRect.h - refSize) / 2,
                h: refSize,
                w: refSize,
                mode: "px"
            });

        }

    }

    class WeekHeader extends BasePanel {
        constructor(parentView, options) {
            super(parentView, options);
            var _this = this;


            // == methods ==


            // == events ==

        }


        // == init ==
        init() {
            super.init();

            // look
            this.look.txtBgNormal = "rgb(200, 200, 200)";
            this.look.txtTxtNormal = "rgb(50, 50, 50)";


            //
            // == ui ==
            this.txts = ["日", "一", "二", "三", "四", "五", "六"];
            this.days = [];

            var COL_W = 100 / 7;
            var refX = 0;
            var cell, txtView;
            for(var i=0; i<7; i++) {
                cell = new BasePanel(this, {
                    rect: { x: refX, w: COL_W }
                });
                txtView = new TextView(cell, {
                    look: {
                        txtScale: 0.4,
                        bgColor: this.look.txtBgNormal,
                        txtColor: this.look.txtTxtNormal,
                        txt: this.txts[i]
                    }
                });
                this.days.push(txtView);
                //
                refX += COL_W;
            }

        }

    }


    var DayButtonPanel = (function() {

        class WeekRow extends BasePanel {
            constructor(parentView, options) {
                super(parentView, options);
                var _this = this;


                // == methods ==


                // == events ==
                for(var i=0; i<7; i++) {
                    (function(I) {

                        _this.days[I].on("click", function() {
                            _this.emit("dateSelected", _this.days[I].dataDate);
                        });

                    })(i);
                }

            }


            // == init ==
            init() {
                super.init();

                // look
                this.look.bgColorThisMonth = COLOR_BTN_BRIGHT;
                this.look.txtColorThisMonth = "rgb(240, 240, 240)";
                this.look.txtColorThisMonth_enter = "rgb(200, 200, 200)";
                this.look.bgColorOtherMonth = "rgb(100, 100, 100)";
                this.look.txtColorOtherMonth = "rgb(240, 240, 240)";
                this.look.txtColorOtherMonth_enter = "rgb(200, 200, 200)";


                //
                // == ui ==
                this.days = [];

                var COL_W = 100 / 7;
                var refX = 0;
                var cell, btn;
                for(var i=0; i<7; i++) {
                    cell = new BasePanel(this, {
                        rect: { x: refX, w: COL_W },
                        look: { padding: 1 }
                    });
                    btn = new ButtonView(cell, {
                        look: {
                            txtScale: 0.4,
                            bgNormal: this.look.bgColorThisMonth,
                            bgEnter: this.look.bgColorThisMonth,
                            bgDown: this.look.bgColorThisMonth,
                            txtNormal: this.look.txtColorThisMonth,
                            txtEnter: this.look.txtColorThisMonth_enter,
                            txtDown: this.look.txtColorThisMonth
                        }
                    });
                    this.days.push(btn);
                    //
                    refX += COL_W;
                }

            }

            //
            initDates(year, month, week) {
                var firstDate = new Date(year, month-1, 1);
                var firstDateDay = firstDate.getDay();
                var firstWeekDays = 7 - firstDateDay;
                var date;

                if(week == 0) {
                    //
                    date = 1;
                    for(var i=firstDateDay; i<7; i++) {
                        this.days[i].setLook({
                            bgNormal: this.look.bgColorThisMonth,
                            bgEnter: this.look.bgColorThisMonth,
                            bgDown: this.look.bgColorThisMonth,
                            txtNormal: this.look.txtColorThisMonth,
                            txtEnter: this.look.txtColorThisMonth_enter,
                            txtDown: this.look.txtColorThisMonth,
                            txt: date
                        });
                        this.days[i].dataDate = new Date(year, month-1, date);//
                        date++;
                    }

                    // 若前面有空格則填入上月剩下天數 (要取得上月有幾天)
                    // var lastDateInLastMonth = new Date(firstDate.getFullYear(), firstDate.getMonth(), 0).getDate(); // NOTE date 設 0 會取到上個月的最後一天
                    var tempDate;
                    var cnt = 1;
                    // var lastMonthDate = lastDateInLastMonth;
                    for(var i=firstDateDay-1; i>=0; i--) {
                        tempDate = firstDate.addDays(-cnt);
                        this.days[i].setLook({
                            bgNormal: this.look.bgColorOtherMonth,
                            bgEnter: this.look.bgColorOtherMonth,
                            bgDown: this.look.bgColorOtherMonth,
                            txtNormal: this.look.txtColorOtherMonth,
                            txtEnter: this.look.txtColorOtherMonth_enter,
                            txtDown: this.look.txtColorOtherMonth,
                            txt: tempDate.getDate()//lastMonthDate
                        });
                        cnt++;//lastMonthDate--;
                        this.days[i].dataDate = new Date(tempDate.getTime());//
                    }

                } else { // other weeks
                    //
                    var firstDateOfThisWeek = new Date(year, month-1, firstWeekDays + 7*(week-1) + 1);
                    var tempDate;
                    var thisMonth = new Date(year, month-1, 1).getMonth();
                    for(var i=0; i<7; i++) {
                        tempDate = firstDateOfThisWeek.addDays(i);
                        if(tempDate.getMonth() != thisMonth) {
                            this.days[i].setLook({
                                bgNormal: this.look.bgColorOtherMonth,
                                bgEnter: this.look.bgColorOtherMonth,
                                bgDown: this.look.bgColorOtherMonth,
                                txtNormal: this.look.txtColorOtherMonth,
                                txtEnter: this.look.txtColorOtherMonth_enter,
                                txtDown: this.look.txtColorOtherMonth,
                                txt: tempDate.getDate()
                            });

                        } else {
                            this.days[i].setLook({
                                bgNormal: this.look.bgColorThisMonth,
                                bgEnter: this.look.bgColorThisMonth,
                                bgDown: this.look.bgColorThisMonth,
                                txtNormal: this.look.txtColorThisMonth,
                                txtEnter: this.look.txtColorThisMonth_enter,
                                txtDown: this.look.txtColorThisMonth,
                                txt: tempDate.getDate()
                            });

                        }

                        this.days[i].dataDate = new Date(tempDate.getTime());//

                    }

                }

            }


        }

        class DayButtonPanel extends BasePanel {
            constructor(parentView, options) {
                super(parentView, options);
                var _this = this;


                // == methods ==


                // == events ==
                for(var i=0; i<6; i++) {
                    (function(I) {

                        _this.weeks[I].on("dateSelected", function(date) {
                            _this.emit("dateSelected", date);
                        });

                    })(i);
                }

            }


            // == init ==
            init() {
                super.init();

                // look
                this.look.bgColor = "rgb(150, 150, 150)";
                this.look.padding = 2;
                //
                this.look.panelBgColor = "rgb(100, 100, 100)";
                this.look.panelTxtColor = "rgb(255, 255, 255)";
                this.look.panelSubTxtColor = "rgb(180, 180, 180)";
                this.look.btnBgColorEnter = "rgb(150, 150, 150)";
                this.look.btnTxtColorEnter = "rgb(255, 255, 255)";
                this.look.btnBgColorDown = "rgb(200, 200, 200)";
                this.look.btnTxtColorDown = "rgb(80, 80, 80)";


                //
                // == ui ==
                var ROW_H = 100 / 6;
                var refY = 0;

                //
                this.weeks = [];
                var cell, weekRow;
                for(var i=0; i<6; i++) {
                    cell = new BasePanel(this, {
                        rect: { y: refY, h: ROW_H }
                    });
                    weekRow = new WeekRow(cell, {
                        // look: {
                        //     bgNormal: this.look.btnBgNormal,
                        //     bgEnter: this.look.btnBgColorEnter,
                        //     bgDown: this.look.btnBgColorDown,
                        //     txtNormal: this.look.btnTxtNormal,
                        //     txtEnter: this.look.btnTxtColorEnter,
                        //     txtDown: this.look.btnTxtColorDown
                        // }
                    });
                    this.weeks.push(weekRow);
                    //
                    refY += ROW_H;
                }

            }


            // ====
            initDates(year, month) {
                for(var i=0; i<6; i++) {
                    this.weeks[i].initDates(year, month, i);
                }

            }


        }


        // ====
        return DayButtonPanel;
    })();

    var DayTogglePanel = (function() {

        class WeekRow extends BasePanel {
            constructor(parentView, options) {
                super(parentView, options);
                var _this = this;


                // == methods ==


                // == events ==
                for(var i=0; i<7; i++) {
                    (function(I) {

                        _this.days[I].on("toggle", function(active) {
                            _this.emit("dateToggled", active, _this.days[I].dataDate.getTime());
                            if(active) {
                                _this.emit("dateSelected", _this.days[I].dataDate);
                            } else {
                                _this.emit("dateUnselected", _this.days[I].dataDate);
                            }
                        });

                    })(i);
                }

            }


            // == init ==
            init() {
                super.init();

                // look
                this.look.thisMonth = {
                    inactive: {
                        bgColor: "rgb(200, 200, 200)",
                        txtColor: "rgb(100, 100, 100)"
                    },
                    active: {
                        bgColor: COLOR_BTN_BRIGHT,
                        txtColor: "rgb(240, 240, 240)"
                    }
                };
                this.look.otherMonth = {
                    inactive: {
                        bgColor: "rgb(100, 100, 100)",
                        txtColor: "rgb(200, 200, 200)"
                    },
                    active: {
                        bgColor: COLOR_BTN_BRIGHT,
                        txtColor: "rgb(240, 240, 240)"
                    }
                };


                // == ui ==
                this.days = [];

                var COL_W = 100 / 7;
                var refX = 0;
                var cell, btn;
                for(var i=0; i<7; i++) {
                    cell = new BasePanel(this, {
                        rect: { x: refX, w: COL_W },
                        look: { padding: 1 }
                    });
                    btn = new ToggleView(cell, {
                        look: { txtScale: 0.4 }
                    });
                    this.days.push(btn);
                    //
                    refX += COL_W;
                }


            }

            //
            initDates(year, month, week, activeDates) {
                var firstDate = new Date(year, month-1, 1);
                var firstDateDay = firstDate.getDay();
                var firstWeekDays = 7 - firstDateDay;
                var date;

                if(week == 0) {
                    //
                    date = 1;
                    for(var i=firstDateDay; i<7; i++) {
                        this.look.thisMonth.inactive.txt = date;
                        this.look.thisMonth.active.txt = date;
                        this.days[i].setLook({
                            inactive: this.look.thisMonth.inactive,
                            active: this.look.thisMonth.active
                        });
                        this.days[i].dataDate = new Date(year, month-1, date);//
                        date++;
                    }

                    // 若前面有空格則填入上月剩下天數 (要取得上月有幾天)
                    var tempDate;
                    var cnt = 1;
                    for(var i=firstDateDay-1; i>=0; i--) {
                        tempDate = firstDate.addDays(-cnt);
                        this.look.otherMonth.inactive.txt = tempDate.getDate();
                        this.look.otherMonth.active.txt = tempDate.getDate();
                        this.days[i].setLook({
                            inactive: this.look.otherMonth.inactive,
                            active: this.look.otherMonth.active
                        });
                        cnt++;
                        this.days[i].dataDate = new Date(tempDate.getTime());//
                    }

                } else { // other weeks
                    //
                    var firstDateOfThisWeek = new Date(year, month-1, firstWeekDays + 7*(week-1) + 1);
                    var tempDate;
                    var thisMonth = new Date(year, month-1, 1).getMonth();
                    for(var i=0; i<7; i++) {
                        tempDate = firstDateOfThisWeek.addDays(i);
                        if(tempDate.getMonth() != thisMonth) {
                            this.look.otherMonth.inactive.txt = tempDate.getDate();
                            this.look.otherMonth.active.txt = tempDate.getDate();
                            this.days[i].setLook({
                                inactive: this.look.otherMonth.inactive,
                                active: this.look.otherMonth.active
                            });

                        } else {
                            this.look.thisMonth.inactive.txt = tempDate.getDate();
                            this.look.thisMonth.active.txt = tempDate.getDate();
                            this.days[i].setLook({
                                inactive: this.look.thisMonth.inactive,
                                active: this.look.thisMonth.active
                            });

                        }

                        this.days[i].dataDate = new Date(tempDate.getTime());//

                    }

                }



                // ====
                this.load(activeDates);

            }

            load(activeDates) {
                for(var i=0; i<7; i++) {
                    if(activeDates[this.days[i].dataDate.getTime()]) {
                        this.days[i].setActive(true, "quiet");
                    } else {
                        this.days[i].setActive(false, "quiet");
                    }
                }
            }
            clear() {
                for(var i=0; i<7; i++) {
                    this.days[i].setActive(false, "quiet");
                }
            }

        }


        class DayTogglePanel extends BasePanel {
            constructor(parentView, options) {
                super(parentView, options);
                var _this = this;

                this.activeDates = {};


                // == methods ==


                // == events ==
                for(var i=0; i<6; i++) {
                    (function(I) {

                        _this.weeks[I].on("dateToggled", function(active, timeIndex) {
                            if(active) {
                                if(!_this.activeDates[timeIndex]) _this.activeDates[timeIndex] = 1;
                            } else {
                                if(_this.activeDates[timeIndex]) delete _this.activeDates[timeIndex];
                            }
                        });

                        _this.weeks[I].on("dateSelected", function(date) {
                            _this.emit("dateSelected", date);
                        });
                        _this.weeks[I].on("dateUnselected", function(date) {
                            _this.emit("dateUnselected", date);
                        });

                    })(i);
                }

            }


            // == init ==
            init() {
                super.init();


                // look
                // this.look.bgColor = "rgb(150, 150, 150)";
                this.look.padding = 2;


                // == ui ==
                var ROW_H = 100 / 6;
                var refY = 0;

                //
                this.weeks = [];
                var cell, weekRow;
                for(var i=0; i<6; i++) {
                    cell = new BasePanel(this, {
                        rect: { y: refY, h: ROW_H }
                    });
                    weekRow = new WeekRow(cell);
                    this.weeks.push(weekRow);
                    //
                    refY += ROW_H;
                }

            }

            // ====
            initDates(year, month) {
                //
                for(var i=0; i<6; i++) {
                    this.weeks[i].initDates(year, month, i, this.activeDates);
                }
            }

            getData() {
                return this.activeDates;
            }
            load(newActiveDates) {
                if(isUsable(newActiveDates)) {
                    var timeIndex;
                    for(var i=0; i<newActiveDates.length; i++) {
                        timeIndex = newActiveDates[i].getTime();
                        if(!this.activeDates[timeIndex]) this.activeDates[timeIndex] = 1;
                    }
                    for(var i=0; i<6; i++) {
                        this.weeks[i].load(this.activeDates);
                    }
                }
            }
            clear() {
                delete this.activeDates;
                this.activeDates = {};
                for(var i=0; i<6; i++) {
                    this.weeks[i].clear();
                }
            }

        }

        // ====
        return DayTogglePanel;
    })();


    //
    class Calendar extends BasePanel {
        constructor(parentView, options, type) {
            super(parentView, options);
            var _this = this;
            var _type = (isUsable(type) ? type : "button");


            // == ui ==
            var monthSelector;
            var dayPanel;
            var UNIT_H = 100 / 7.5;

            switch(_type) {
                case "toggle":
                    dayPanel = new DayTogglePanel(this.boxPanel, {
                        rect: { y: UNIT_H * 1.5, h: UNIT_H * 6 }
                    });
                    break;

                default: // "button"
                    dayPanel = new DayButtonPanel(this.boxPanel, {
                        rect: { y: UNIT_H * 1.5, h: UNIT_H * 6 }
                    });

            }
            this.dayPanel = dayPanel;



            // == methods ==
            function initMonthSelector() {
                monthSelector = new MonthSelector(_this.boxPanel);
                monthSelector.on("monthSelected", function(year, month) {
                    _this.year = year;
                    _this.month = month;
                    _this.setDate(_this.year, _this.month+1);
                    monthSelector.hide();
                });
            }
            function showMonthSelector() {
                if(!monthSelector) initMonthSelector();
                monthSelector.show(_this.year);
            }


            // == events ==
            this.controlPanel.on("upClicked", function() {
                var now = new Date(_this.year, _this.month-1, 1);
                var lastMonth = now.addMonths(-1);
                _this.setDate(lastMonth.getFullYear(), lastMonth.getMonth()+1);

            });
            this.controlPanel.on("downClicked", function() {
                var now = new Date(_this.year, _this.month-1, 1);
                var lastMonth = now.addMonths(1);
                _this.setDate(lastMonth.getFullYear(), lastMonth.getMonth()+1);

                // // NOTE test clear()
                // _this.dayPanel.clear();

            });
            this.controlPanel.on("yearMonthClicked", function() {
                showMonthSelector();

                // // NOTE test getDate()
                // console.log(_this.dayPanel.getData());
                // var data = _this.dayPanel.getData();
                // for(var id in data) {
                //     console.log(new Date(parseInt(id.toString())).toYYYYMMdd());
                // }

            });

            this.dayPanel.on("dateSelected", function(date) {
                // console.log(date.toYYYYMMdd());
                _this.emit("dateSelected", date);
            });
            this.dayPanel.on("dateUnselected", function(date) {
                // console.log(date.toYYYYMMdd());
                _this.emit("dateUnselected", date);
            });

            this.boxPanel.domOn("click", function() {});
            this.domOn("click", function() {
                _this.emit("maskClicked");
            });


            // ==
            if(isUsable(options) && isUsable(options.rect) && (isUsable(options.rect.constW) || isUsable(options.rect.constH))) {
                if(isUsable(options.rect.constW)) _this.rect.constW = options.rect.constW;
                if(isUsable(options.rect.constH)) _this.rect.constH = options.rect.constH;
                _this.redraw(true);
            }

        }


        // == init ==
        init() {
            super.init();

            var now = new Date();
            this.year = now.getFullYear();
            this.month = now.getMonth();

            //
            var _this = this;
            var MASK_COLOR = "rgba(50, 50, 50, 0.7)";

            // look
            this.look.bgColor = MASK_COLOR;
            //
            this.look.txtBack = "Back";
            this.look.txtDone = "Done";
            this.look.panelBgColor = "rgb(150, 150, 150)";
            this.look.panelTxtColor = "rgb(255, 255, 255)";
            this.look.panelSubTxtColor = "rgb(180, 180, 180)";
            this.look.btnBgColorEnter = "rgb(150, 150, 150)";
            this.look.btnTxtColorEnter = "rgb(255, 255, 255)";
            this.look.btnBgColorDown = "rgb(200, 200, 200)";
            this.look.btnTxtColorDown = "rgb(80, 80, 80)";

            // opts
            this.opts.visible = false;


            // == ui ==

            var boxPanel = new BasePanel(this, {
                // rect: { x: 5, y: 5, w: 90, h: 90 },
                look: {
                    bgColor: this.look.panelBgColor,
                    borderRadius: 5
                },
                boxShadow: {
                    visible: true
                }
            })

            var UNIT_H = 100 / 7.5;

            var controlPanel = new ControlPanel(boxPanel, {
                rect: { y: UNIT_H * 0, h: UNIT_H * 1 }
            });

            var weekHeader = new WeekHeader(boxPanel, {
                rect: { y: UNIT_H * 1, h: UNIT_H * 0.5 }
            });

            // var rightPanel = new BasePanel(this, {
            //     look: {
            //         bgColor: this.look.panelBgColor,
            //         borderRadius: 5
            //     },
            //     boxShadow: {
            //         visible: true
            //     }
            // });
            // var bottomPanel = new BasePanel(this, {
            //     look: {
            //         bgColor: this.look.panelBgColor,
            //         borderRadius: 5
            //     },
            //     boxShadow: {
            //         visible: true
            //     }
            // });


            //
            this.controlPanel = controlPanel;
            this.boxPanel = boxPanel;
            // this.dayPanel = dayPanel;
            // this.rightPanel = rightPanel;
            // this.bottomPanel = bottomPanel;

        }


        // == redraw ==

        // rect
        redrawRect() {
            // NOTE 新增屬性的預設值必須在這設
            this.rect.constW = (this.rect.constW ? this.rect.constW : 700);
            this.rect.constH = (this.rect.constH ? this.rect.constH : 750);

            //
            var parentRect = this.parentView.RectPx;
            var BOX_X = (parentRect.w - this.rect.constW) / 2;
            var BOX_Y = (parentRect.h - this.rect.constH) / 2;
            var BOX_W = this.rect.constW;
            var BOX_H = this.rect.constH;
            this.boxPanel.setRect({
                x: BOX_X,
                y: BOX_Y,
                w: BOX_W,
                h: BOX_H,
                mode: "px"
            });

            // var SPACE = 4;
            //
            // this.rightPanel.setRect({
            //     x: BOX_X + BOX_W + SPACE,
            //     y: BOX_Y,
            //     w: BOX_W * (2/7),
            //     h: BOX_H,
            //     mode: "px"
            // });
            //
            // this.bottomPanel.setRect({
            //     x: BOX_X,
            //     y: BOX_Y + BOX_H + SPACE,
            //     w: BOX_W * (1 + 2/7) + SPACE,
            //     h: BOX_H * (1/7.5),
            //     mode: "px"
            // });


            super.redrawRect();
        }

        // look
        // redrawLook() {
        //     super.redrawLook();
        //
        //     this.btnBack.setLook({
        //         txt: this.look.txtBack,
        //         bgNormal: this.look.panelBgColor,
        //         bgEnter: this.look.btnBgColorEnter,
        //         bgDown: this.look.btnBgColorDown,
        //         txtNormal: this.look.panelTxtColor,
        //         txtEnter: this.look.btnTxtColorEnter,
        //         txtDown: this.look.btnTxtColorDown,
        //     });
        //     this.btnDone.setLook({
        //         txt: this.look.txtDone,
        //         bgNormal: this.look.panelBgColor,
        //         bgEnter: this.look.btnBgColorEnter,
        //         bgDown: this.look.btnBgColorDown,
        //         txtNormal: this.look.panelTxtColor,
        //         txtEnter: this.look.btnTxtColorEnter,
        //         txtDown: this.look.btnTxtColorDown,
        //     });
        //
        //
        //     this.boxPanel.redraw(true); // NOTE 看來很多介面不會自己動的問題, 都是因為沒像這樣要求 child redraw
        //
        // }


        setDate(year, month) {
            this.year = year;
            this.month = month;
            this.controlPanel.setYearMonth(year, month);
            this.dayPanel.initDates(year, month);
        }

        loadActiveDates(activeDates) {
            this.dayPanel.load(activeDates);
        }
        clearActiveDates() {
            this.dayPanel.clear();
        }


    }


    // ====
    return Calendar;
})();


// ====
module.exports = Calendar;

},{"../basic/ButtonView":1,"../basic/TextView":4,"../basic/ToggleView":5,"./BasePanel":9,"./ListItem":11,"./ListPanel":12}],11:[function(require,module,exports){

var BasePanel = require("./BasePanel");

// ====

var ListItem = (function() {
    //

    //
    class ListItem extends BasePanel {
        constructor(parentView, options, data) {
            super(parentView, options);
            var _this = this;

            this.idx = -1;
            this.data = data;


            // == events ==
            this.domOn("click", function() {
                _this.emit("click");
            });
            this.domOn("dblclick", function() {
                _this.emit("dblclick");
            });


        }


        // ====
        set Index(idx) {
            this.idx = idx;
        }
        get Index() {
            return this.idx;
        }



    }


    //
    return ListItem;
})();


//
module.exports = ListItem;

},{"./BasePanel":9}],12:[function(require,module,exports){

var BasePanel = require("./BasePanel");

// ====

var ListPanel = (function() {
    //
    function createTargetView(ctx, TargetView, options, data) {
        var newItem = new TargetView(ctx, options, data);
        newItem.on("click", function() {
            ctx.emit("itemClicked", this);
        });
        newItem.on("dblclick", function() {
            ctx.emit("itemDblClicked", this);
        });
        return newItem;
    }

    //
    class ListPanel extends BasePanel {
        constructor(parentView, options) {
            super(parentView, options);
            var _this = this;

        }

        // == init ==
        init() {
            super.init();

            // opts
            this.opts.orientation = "vertical";

            //
            this.itemArr = [];

        }


        // == redraw ==

        // opts
        redrawOpts() {
            super.redrawOpts();

            if(this.opts.orientation == "horizontal") {
                this.setOverflow({
                    x: "scroll",
                    y: "hidden"
                });
            } else {                    // vertical
                this.setOverflow({
                    x: "hidden",
                    y: "scroll"
                });
            }

        }



        // ====

        //
        // NOTE TargetView must be extended from ListItem
        // NOTE options.rect 只有 w 或 h 有效. (VERTICAL 的 w 與 HORIZONTAL 的 h 一定是 100)
        // NOTE >> 前項的值改成 size
        createNewItems(TargetView, size, data) {
            var _this = this;

            var options;
            if(this.opts.orientation == "horizontal") {
                options = {
                    rect: {
                        w: size,
                        h: 100,
                        mode: "%"
                    }
                };
            } else {                    // vertical
                options = {
                    rect: {
                        w: 100,
                        h: size,
                        mode: "%"
                    }
                };
            }

            var newItem;
            var newItems = [];
            if(Array.isArray(data)) {
                for(var i=0; i<data.length; i++) {
                    newItems.push(createTargetView(_this, TargetView, options, data[i]));
                }
            } else {
                newItems.push(createTargetView(_this, TargetView, options, data));
            }
            return newItems;
        }
        addToHead(TargetView, options, data) {
            var newItems = this.createNewItems(TargetView, options, data);
            this.itemArr = newItems.concat(this.itemArr);
            this.redrawItems();
        }
        addToTail(TargetView, options, data) {
            var newItems = this.createNewItems(TargetView, options, data);
            this.itemArr = this.itemArr.concat(newItems);
            this.redrawItems();
        }
        redrawItems() {
            var ref = 0;

            for(var i=0; i < this.itemArr.length; i++) {
                this.itemArr[i].Index = i;

                if(this.opts.orientation == "horizontal") {
                    this.itemArr[i].setRect({
                        x: ref,
                        y: 0
                    });
                    ref += this.itemArr[i].rect.w;

                } else {                    // vertical
                    this.itemArr[i].setRect({
                        x: 0,
                        y: ref
                    });
                    ref += this.itemArr[i].rect.h;

                }

            }

        }

        remove(idx) {
            var targetItem = this.itemArr[idx];
            if(targetItem) {
                targetItem.dispose();
                this.itemArr.splice(idx, 1);
                this.redrawItems();
            }
        }
        clear() {
            for(var i=0; i<this.itemArr.length; i++) {
                this.itemArr[i].dispose();
            }
            this.itemArr = [];
        }
        load(TargetView, size, dataList) {  // alias of addToTail
            this.addToTail(TargetView, size, dataList);
        }

        scrollTo(idx, animate, duration) {
            // NOTE 若沒空間捲了, 不一定會到頂
            var _animate = (isUsable(animate) ? animate : false);
            var _duration = (isUsable(duration) ? duration : 500);

            var ref = 0;
            if(this.opts.orientation == "horizontal") {
                for(var i=0; i<this.itemArr.length; i++) {
                    if(i < idx) {
                        ref += this.itemArr[i].PxW;
                    } else {
                        break;
                    }
                }

                if(_animate) {
                    this.animate({ scroll: { x: ref }, duration: _duration });
                } else {
                    this.core.scrollleft = ref;
                }

            } else {                    // vertical
                for(var i=0; i<this.itemArr.length; i++) {
                    if(i < idx) {
                        ref += this.itemArr[i].PxH;
                    } else {
                        break;
                    }
                }

                if(_animate) {
                    this.animate({ scroll: { y: ref }, duration: _duration });
                } else {
                    this.core.scrollTop = ref;
                }

            }

        }

        getDataOf(idx) {
            return (isUsable(this.itemArr[idx]) ? this.itemArr[idx].data : null);
        }

    }


    //
    return ListPanel;
})();


//
module.exports = ListPanel;

},{"./BasePanel":9}],13:[function(require,module,exports){

// == methods ==

window.isUsable = function(obj) {
    if(typeof(obj) !== "undefined" && obj != null) {
        return true;
    } else {
        return false;
    }
}

window.isNumeric = function(n) {
     return !isNaN(parseFloat(n)) && isFinite(n);
}

window.randomString = function(length, chars) {
    var mask = '';
    if (chars.indexOf('a') > -1) mask += 'abcdefghijklmnopqrstuvwxyz';
    if (chars.indexOf('A') > -1) mask += 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
    if (chars.indexOf('#') > -1) mask += '0123456789';
    if (chars.indexOf('!') > -1) mask += '~`!@#$%^&*()_+-={}[]:";\'<>?,./|\\';
    var result = '';
    for (var i = length; i > 0; --i) result += mask[Math.floor(Math.random() * mask.length)];
    return result;
    //
    // console.log(randomString(16, 'aA'));
    // console.log(randomString(32, '#aA'));
    // console.log(randomString(64, '#A!'));
}

window.splitString = function(str, size) {
    //TODO check performance
    var re = new RegExp('.{1,' + size + '}', 'g');
    return str.match(re);
}

window.getUrlParam = function(name) {
    url = window.location.href;
    name = name.replace(/[\[\]]/g, "\\$&");
    var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)"),
        results = regex.exec(url);
    if (!results) return null;
    if (!results[2]) return '';
    return decodeURIComponent(results[2].replace(/\+/g, " "));
}

// // Object
// Object.prototype.clone = function() {
//     return Object.assign({}, this);
// }
// Object.prototype.assignToTargetOwnProps = function(target) {
//     // 目標是把 this 的 property 寫進 target, 但不是全部都寫
//     // 只挑 target 也有的 property, 才把值寫進去
//     var props = Object.getOwnPropertyNames(target);
//     var prop;
//     for(k in props) {
//         prop = props[k];
//         if(isUsable(this[prop])) {
//             if(isUsable(target[prop]) && typeof target[prop] === "object") {
//                 this[prop].assignToTargetOwnProps(target[prop]);
//             } else {
//                 target[prop] = this[prop];
//             }
//         }
//     }
// }
window.clone = function(from) {
    return Object.assign({}, from);
}
window.assignToTargetOwnProps = function(from, target) {
    // 目標是把 this 的 property 寫進 target, 但不是全部都寫
    // 只挑 target 也有的 property, 才把值寫進去
    var props = Object.getOwnPropertyNames(target);
    var prop;
    for(k in props) {
        prop = props[k];
        if(isUsable(from[prop])) {
            if(isUsable(target[prop]) && typeof target[prop] === "object") {
                assignToTargetOwnProps(from[prop], target[prop]);
            } else {
                target[prop] = from[prop];
            }
        }
    }
}

window.tryParseJSON = function(str) {
    var obj;
    try {
        obj = JSON.parse(str);
    } catch (e) {
        console.log("[tryParseJSON]", e);
        obj = null;
    }
    return obj;
}

//
String.prototype.startsWith = function (prefix) {
    return (this.substr(0, prefix.length) === prefix);
}
String.prototype.endsWith = function (suffix) {
    return (this.substr(this.length - suffix.length) === suffix);
}
String.prototype.contains = function (txt) {
    return (this.indexOf(txt) >= 0);
}
String.prototype.paddingLeft = function (paddingValue) {
    return String(paddingValue + this).slice(-paddingValue.length);
};
String.prototype.splitTrim = function(sep) {
    var arr = this.split(sep);
    for(i=0; i<arr.length; i++) {
        arr[i] = arr[i].trim();
    }
    return arr;
}

//
Date.prototype.addYears = function(years, addToNewInstance) {
    var newInstance = (typeof addToNewInstance != "undefined") ? addToNewInstance : true;

    if(newInstance) {
        var date = new Date(this.valueOf());
        date.setFullYear(date.getFullYear() + years);
        return date;

    } else {
        this.setFullYear(this.getFullYear() + years);
        return this;

    }

}
Date.prototype.addMonths = function(months, addToNewInstance) {
    var newInstance = (typeof addToNewInstance != "undefined") ? addToNewInstance : true;

    if(newInstance) {
        var date = new Date(this.valueOf());
        date.setMonth(date.getMonth() + months);
        return date;

    } else {
        this.setMonth(this.getMonth() + months);
        return this;

    }

}
Date.prototype.addDays = function(days, addToNewInstance) {
    var newInstance = (typeof addToNewInstance != "undefined") ? addToNewInstance : true;

    if(newInstance) {
        var date = new Date(this.valueOf());
        date.setDate(date.getDate() + days);
        return date;

    } else {
        this.setDate(this.getDate() + days);
        return this;

    }

}
Date.prototype.addHours = function(hours, addToNewInstance) {
    var newInstance = (typeof addToNewInstance != "undefined") ? addToNewInstance : true;

    if(newInstance) {
        var date = new Date(this.valueOf());
        date.setHours(date.getHours() + hours);
        return date;

    } else {
        this.setHours(this.getHours() + hours);
        return this;

    }

}
Date.prototype.addMinutes = function(minutes, addToNewInstance) {
    var newInstance = (typeof addToNewInstance != "undefined") ? addToNewInstance : true;

    if(newInstance) {
        var date = new Date(this.valueOf());
        date.setMinutes(date.getMinutes() + minutes);
        return date;

    } else {
        this.setMinutes(this.getMinutes() + minutes);
        return this;

    }

}
Date.prototype.toYYYYMMdd = function() {
    return this.getFullYear().toString() + "/" + (this.getMonth() + 1).toString().paddingLeft('00') + "/" + this.getDate().toString().paddingLeft('00');
}
Date.prototype.toYYYYMM = function() {
    return this.getFullYear().toString() + "/" + (this.getMonth() + 1).toString().paddingLeft('00');
}
Date.prototype.toHHmm = function() {
    return this.getHours().toString().paddingLeft('00') + ":" + this.getMinutes().toString().paddingLeft('00');
}
Date.prototype.toMMddHHmm = function() {
    return (this.getMonth() + 1).toString().paddingLeft('00') + '/' + this.getDate().toString().paddingLeft('00') + " " + this.getHours().toString().paddingLeft('00') + ':' + this.getMinutes().toString().paddingLeft('00');
}
Date.prototype.toMMddHHmmss = function() {
    return (this.getMonth() + 1).toString().paddingLeft('00') + '/' + this.getDate().toString().paddingLeft('00') + " " + this.getHours().toString().paddingLeft('00') + ':' + this.getMinutes().toString().paddingLeft('00') + ':' + this.getSeconds().toString().paddingLeft('00');
}
Date.prototype.toMMdd = function() {
    return (this.getMonth() + 1).toString().paddingLeft('00') + '/' + this.getDate().toString().paddingLeft('00');
}
Date.prototype.toYYYYMMddHHmm = function() {
    return this.getFullYear().toString() + "/" + (this.getMonth() + 1).toString().paddingLeft('00') + '/' + this.getDate().toString().paddingLeft('00') + " " + this.getHours().toString().paddingLeft('00') + ':' + this.getMinutes().toString().paddingLeft('00');
}
Date.prototype.toDay = function() {
    switch(this.getDay()) {
        case 0:
            return "週日";
        case 1:
            return "週一";
        case 2:
            return "週二";
        case 3:
            return "週三";
        case 4:
            return "週四";
        case 5:
            return "週五";
        case 6:
            return "週六";
    }
}

// == Timer ==
window.Timer = function(func, delay) {
    var handle = null;
    var _func = func;
    var _delay = delay;

    function start(newDelay) {
        if (typeof newDelay !== "undefined") {
            _delay = newDelay;
        }
        stop();
        handle = setTimeout(_func, _delay);
    }
    function stop() {
        if (handle) {
            clearTimeout(handle);
            handle = null;
        }
    }

    this.start = start;
    this.stop = stop;

}
window.Looper = function(func, interval) {
    var handle = null;
    var _func = func;
    var _interval = interval;

    function start(newInterval) {
        if (typeof newInterval !== "undefined") {
            _interval = newInterval;
        }
        stop();
        handle = setInterval(_func, _interval);
    }
    function stop() {
        if (handle) {
            clearInterval(handle);
            handle = null;
        }
    }

    this.start = start;
    this.stop = stop;

}

//
window.QueryString = function () {
    // This function is anonymous, is executed immediately and
    // the return value is assigned to QueryString!
    var query_string = {};
    var query = window.location.search.substring(1);
    var vars = query.split("&");
    for (var i=0;i<vars.length;i++) {
        var pair = vars[i].split("=");
            // If first entry with this name
        if (typeof query_string[pair[0]] === "undefined") {
          query_string[pair[0]] = decodeURIComponent(pair[1]);
            // If second entry with this name
        } else if (typeof query_string[pair[0]] === "string") {
          var arr = [ query_string[pair[0]],decodeURIComponent(pair[1]) ];
          query_string[pair[0]] = arr;
            // If third or later entry with this name
        } else {
          query_string[pair[0]].push(decodeURIComponent(pair[1]));
        }
    }
    return query_string;
}();

},{}],14:[function(require,module,exports){

require("./global");

var RootView = require('../../../basic/RootView');
var Calendar = require("../../Calendar");


// ====

var root = new RootView();


var calendar = new Calendar(root, {
    rect: {
        constW: 350,
        constH: 375,
    }
});
calendar.setDate(2018, 2);
// calendar.setNights(3);
calendar.show();

// var nights = 5;
// function selectNights(date) {
//     calendar.clearActiveDates();
//     //
//     var newActiveDates = [date];
//     for(var i=1; i<nights; i++) {
//         newActiveDates.push(date.addDays(i));
//     }
//     calendar.loadActiveDates(newActiveDates);
// }
//
// calendar.on("dateSelected", selectNights);
// calendar.on("dateUnselected", selectNights);

},{"../../../basic/RootView":3,"../../Calendar":10,"./global":13}]},{},[14]);
