
require("../node_modules/ber-client-global/lib/global");

var DivView = require("./basic/DivView");
var RootView = require("./basic/RootView");
var TextView = require("./basic/TextView");
var ButtonView = require("./basic/ButtonView");
var ToggleView = require("./basic/ToggleView");
var TextBoxView = require("./basic/TextBoxView");
var TextAreaView = require("./basic/TextAreaView");
var ImageView = require("./basic/ImageView");
var CanvasView = require("./basic/CanvasView");
var FileView = require("./basic/FileView");
var IFrameView = require("./basic/IFrameView");
var VideoView = require("./basic/VideoView");

var BasePanel = require("./ext/BasePanel");
var ListItem = require("./ext/ListItem");
var ListPanel = require("./ext/ListPanel");
var CapturePanel = require("./ext/CapturePanel");
var ConfirmPanel = require("./ext/ConfirmPanel");
var AlertPanel = require("./ext/AlertPanel");
var DatePicker = require("./ext/DatePicker");
var DateTimePicker = require("./ext/DateTimePicker");
var GenericPicker = require("./ext/GenericPicker");
var Slider = require("./ext/Slider");
var Calendar = require("./ext/Calendar");
// var CalendarNightSelector = require("./ext/CalendarNightSelector");

// ====

module.exports = {
    DivView: DivView,
    RootView: RootView,
    TextView: TextView,
    ButtonView: ButtonView,
    ToggleView: ToggleView,
    TextBoxView: TextBoxView,
    TextAreaView: TextAreaView,
    ImageView: ImageView,
    CanvasView: CanvasView,
    FileView: FileView,
    IFrameView: IFrameView,
    VideoView: VideoView,

    BasePanel: BasePanel,
    ListItem: ListItem,
    ListPanel: ListPanel,
    CapturePanel: CapturePanel,
    ConfirmPanel: ConfirmPanel,
    AlertPanel: AlertPanel,
    DatePicker: DatePicker,
    DateTimePicker: DateTimePicker,
    GenericPicker: GenericPicker,
    Slider: Slider,
    Calendar: Calendar,
    // CalendarNightSelector: CalendarNightSelector
};
