
var BerUI = require("../../index");

// ====

var Canvas = (function() {
    //

    //
    class Canvas extends BerUI.BasePanel {
        constructor(parentView, options) {
            super(parentView, options);
            var _this = this;


            // == ui ==

            // // NOTE: 把 itemData 轉串成此元件擴展的屬性
            // if(itemData) {
            //     if(itemData.value) this.look.value = itemData.value;
            // }


            // == methods ==


            // == events ==


        }

        init() {
            super.init();

            //
            this.look.value = {
                src: "",
                bgColor: BerColor.Transparent,

                padding: 2,
                borderRadius: 4,

                canvasPadding: 0

            };


            // == ui ==
            var cellValue = new BerUI.BasePanel(this);
            var _cellValue = new BerUI.BasePanel(cellValue);
            var canvas = new BerUI.CanvasView(_cellValue);


            //
            this.cellValue = cellValue;
            this.canvas = canvas;

        }

        redrawLook() {
            super.redrawLook();

            var valueLook = this.look.value;

            this.cellValue.setLook({
                padding: valueLook.padding,
            });

            this.canvas.setLook({
                padding: valueLook.canvasPadding,
                borderRadius: valueLook.borderRadius,
                bgColor: valueLook.bgColor,
                src: valueLook.src,
            });

        }

        //
        set Value(src) {
            this.look.value.src = src;
            this.redrawLook();
        }
        get Value() {
            return this.look.value.src;
        }


    }


    //
    return Canvas;
})();


//
module.exports = Canvas;
