
var BerList = require("../../../cus-ui/BerList");

// ====

var PopupList = (function() {
    //
    var itemOpts = {

        // // BerList 根據這段建立 Header 物件. 若沒有此項, 則列表不會有 Header.
        // header: [
        //     [{
        //         id: "name",
        //         type: "text",
        //         value: "Name",
        //         valueAlign: "center",
        //     }, {
        //         id: "amount",
        //         type: "text",
        //         value: "Amount",
        //         valueAlign: "center",
        //     }]
        // ],

        // BerList 根據這段建立 Row 物件
        row: [
            [{
                id: "value",
                type: "button",
                look: {
                    value: {
                        // txt: "",
                        padding: 2,
                        borderRadius: 4
                    }
                }
            }],
        ],

    };

    //
    class PopupList extends BerList {
        constructor(parentView, options) {
            super(parentView, options, itemOpts);
            var _this = this;


            // == ui ==


            // == methods ==


            // == events ==


            // // TEMP:
            // this.load([{
            //     name: "a",
            //     amount: 1
            // }, {
            //     name: "b",
            //     amount: 2
            // }, {
            //     name: "c",
            //     amount: 3
            // }]);

        }

        init() {
            super.init();

            // this.look.headerBgColor = "white";
            this.look.rowBgColor = BerColor.Transparent;

            this.look.bgColor = BerColor.Transparent;

        }

    }


    //
    return PopupList;
})();


//
module.exports = PopupList;
