
var BerUI = require("../../index");

// ====

var Text = (function() {
    //

    //
    class Text extends BerUI.BasePanel {
        constructor(parentView, options) {
            super(parentView, options);
            var _this = this;


            // == ui ==


            // == methods ==


            // == events ==


        }

        init() {
            super.init();

            //
            this.look.value = {
                txt: "",
                txtColor: BerColor.Darker,
                bgColor: BerColor.Transparent,
                txtAlign: "left",
                txtScale: 0.4,

                padding: 2,
                borderRadius: 4

            };

            // == ui ==
            var cellValue = new BerUI.BasePanel(this);
            var txtValue = new BerUI.TextView(cellValue);

            //
            this.cellValue = cellValue;
            this.txtValue = txtValue;

        }

        redrawLook() {
            super.redrawLook();

            var valueLook = this.look.value;

            this.cellValue.setLook({
                padding: valueLook.padding
            });

            this.txtValue.setLook({
                borderRadius: valueLook.borderRadius,
                bgColor: valueLook.bgColor,
                txtColor: valueLook.txtColor,
                txtScale: valueLook.txtScale,
                txtAlign: valueLook.txtAlign,
                txt: valueLook.txt,
            });

        }

        //
        set Value(val) {
            this.look.value.txt = val;
            this.txtValue.Value = val;
        }
        get Value() {
            return this.txtValue.Value;
        }


    }


    //
    return Text;
})();


//
module.exports = Text;
