
var ListPanel = CusUI.List.Panel;
var RecordHeader = require("./RecordHeader");
var RecordItem = require("./RecordItem");

// ====

var RecordListPanel = (function() {
    //

    //
    class RecordListPanel extends ListPanel {
        constructor(parentView, options) {
            super(parentView, options, RecordHeader, RecordItem);
            var _this = this;


            // == ui ==
            this.initHeader({
                bookingCode: "訂單編號",
                supplier: "供應商",
                agentName: "Agent",
                location: "國家城市",
                hotelName: "飯店",
                bookingDate: "下單時間",
                deadline: "保住",
                checkIn: "入住",
                checkOut: "退房",
                customerName: "顧客",
                price: "金額",
                status: "狀態"
            });


            // == methods ==


            // == events ==


        }

    }


    //
    return RecordListPanel;
})();


//
module.exports = RecordListPanel;
