
var BerPanel = require("../../../cus-ui/BerPanel");//CusUI.BerPanel;

// ====

var CustomItems = [ {
    id: "customtext",
    item: require("./CustomText")
}];

var BerBerPanel = (function() {
    //
    var itemSettings = [

        [{
            id: "t",
            type: "customtext",
            look: {
                value: {
                    // txt: "text",
                    bgColor: "red",
                    txtColor: "blue",
                    txtAlign: "center",
                    borderRadius: 0,
                    padding: 0
                }
            }
        }, {
            id: "tt",
            type: "titletext",
            look: {
                title: {
                    txt: "ttt bbb",
                    // bgColor: "red",
                    borderRadius: 0,
                    padding: 0
                },
                value: {
                    txt: "text",
                    // bgColor: "red",
                    borderRadius: 0,
                    padding: 0
                }
            }
        }, {
            id: "b",
            type: "button",
            look: {
                value: {
                    txt: "button",
                    bgColor: "red",
                    borderRadius: 0,
                    padding: 0
                }
            }
        }, {
            id: "tb",
            type: "titlebutton",
            look: {
                title: {
                    txt: "ttt bbb",
                    // bgColor: "red",
                    borderRadius: 0,
                    padding: 0
                },
                value: {
                    txt: "button",
                    // bgColor: "red",
                    borderRadius: 0,
                    padding: 0
                }
            }
        }, {
            id: "ch",
            type: "check",
            look: {
                value: {
                    txt: "check",
                    // txtColor: BerColor.Darker,
                    // bgColor: "white",
                }
            },
        }, {
            id: "tch",
            type: "titlecheck",
            look: {
                title: {
                    txt: "title",
                    // bgColor: "red",
                    borderRadius: 0,
                    padding: 0
                },
                value: {
                    txt: "check",
                    // bgColor: "red",
                    borderRadius: 0,
                    padding: 0
                }
            }
        }],

        [{
            id: "tbox",
            type: "textbox",
            look: {
                value: {
                    txt: "1234",
                    // txtColor: BerColor.Darker,
                    // bgColor: "white",
                    // txtAlign: "left",
                    // txtScale: 0.4,
                    //
                    // placeholder: "",
                    //
                    // padding: 4,
                    // borderRadius: 4,
                    //
                    // frameSize: 8,
                    // frameColor: "red",
                }
            },
            opts: {
                value: {
                    textType: "string",
                    readonly: false,
                }
            }
        }, {
            id: "tbox",
            type: "titlebox",
            look: {
                title: {
                    txt: "titlebox !",
                    // bgColor: "red",
                    borderRadius: 0,
                    padding: 0
                },
                value: {
                    txt: "1234",
                    // txtColor: BerColor.Darker,
                    // bgColor: "white",
                    // txtAlign: "left",
                    // txtScale: 0.4,
                    //
                    // placeholder: "",
                    //
                    // padding: 4,
                    // borderRadius: 4,
                    //
                    // frameSize: 8,
                    // frameColor: "red",
                }
            },
            opts: {
                value: {
                    textType: "string",
                    readonly: false,
                }
            }
        }],

        [{
            id: "can",
            type: "canvas",
            look: {
                value: {
                    src: "img/sys/beach.png",
                    // bgColor: "white",
                    //
                    // padding: 2,
                    // borderRadius: 4
                }
            }
        }, {
            id: "tcan",
            type: "titlecanvas",
            look: {
                title: {
                    txt: "title",
                    // bgColor: "red",
                    borderRadius: 0,
                    padding: 0
                },
                value: {
                    src: "img/sys/beach.png",
                    bgColor: "white",
                    //
                    // padding: 2,
                    // borderRadius: 4
                }
            }
        }, {
            id: "cb",
            type: "canvasbutton",
            look: {
                value: {
                    normalSrc: "img/sys/beach.png",
                    activeSrc: "img/sys/wifi.png",
                    // bgColor: "white",
                    // borderRadius: 0,
                    // padding: 0
                }
            }
        }, {
            id: "tcb",
            type: "titlecanvasbutton",
            look: {
                title: {
                    txt: "title",
                    // bgColor: "red",
                    borderRadius: 0,
                    padding: 0
                },
                value: {
                    normalSrc: "img/sys/beach.png",
                    activeSrc: "img/sys/wifi.png",
                    // bgColor: "white",
                    // borderRadius: 0,
                    // padding: 0
                }
            }
        }, {
            id: "cch",
            type: "canvascheck",
            look: {
                value: {
                    normalSrc: "img/sys/beach.png",
                    activeSrc: "img/sys/wifi.png",
                    // bgColor: "white",
                    // borderRadius: 0,
                    // padding: 0
                }
            },
        }, {
            id: "tcch",
            type: "titlecanvascheck",
            look: {
                title: {
                    txt: "title",
                    // bgColor: "red",
                    borderRadius: 0,
                    padding: 0
                },
                value: {
                    normalSrc: "img/sys/beach.png",
                    activeSrc: "img/sys/wifi.png",
                    // bgColor: "white",
                    // borderRadius: 0,
                    // padding: 0
                }
            }
        }],

        [{
            id: "ddbtn",
            type: "dropdownbutton",
            look: {
                value: {
                    txt: "button",
                    // bgColor: "red",
                    borderRadius: 0,
                    padding: 0
                },
                dropdown: {
                    maxVisibleRows: 2,
                }
            }
        }, {
            id: "tddbtn",
            type: "titledropdownbutton",
            look: {
                title: {
                    txt: "title",
                    // bgColor: "red",
                    borderRadius: 0,
                    padding: 0
                },
                value: {
                    txt: "button",
                    // bgColor: "red",
                    borderRadius: 0,
                    padding: 0
                },
                dropdown: {
                    maxVisibleRows: 2,
                }
            }
        }, {
            id: "ddbox",
            type: "dropdownbox",
            look: {
                value: {
                    txt: "1234",
                    // txtColor: BerColor.Darker,
                    // bgColor: "white",
                    // txtAlign: "left",
                    // txtScale: 0.4,
                    //
                    // placeholder: "",
                    //
                    // padding: 4,
                    // borderRadius: 4,
                    //
                    // frameSize: 8,
                    // frameColor: "red",
                },
                dropdown: {
                    maxVisibleRows: 2,
                }
            },
            opts: {
                value: {
                    textType: "string",
                    readonly: false,
                }
            }
        }, {
            id: "tddbox",
            type: "titledropdownbox",
            look: {
                title: {
                    txt: "titlebox !",
                    // bgColor: "red",
                    borderRadius: 0,
                    padding: 0
                },
                value: {
                    txt: "1234",
                    // txtColor: BerColor.Darker,
                    // bgColor: "white",
                    // txtAlign: "left",
                    // txtScale: 0.4,
                    //
                    // placeholder: "",
                    //
                    // padding: 4,
                    // borderRadius: 4,
                    //
                    // frameSize: 8,
                    // frameColor: "red",
                },
                dropdown: {
                    maxVisibleRows: 2,
                }
            },
            opts: {
                value: {
                    textType: "string",
                    readonly: false,
                }
            }
        }],

        [{
            id: "sep",
            type: "separator",
            look: {
                // bgColor: BerColor.Mid,
                // borderRadius: 4,
                value: {
                    borderRadius: 4,
                    color: BerColor.Bright,
                    // size: 2,
                    lineHeightPx: 8,
                    lineWidthPct: 60,
                    lineBorderRadius: 4,
                }
            }
        }],

        [{
            id: "ch",
            type: "switch",
            look: {
                value: {
                    txt: "switch",
                    // txtColor: BerColor.Darker,
                    // bgColor: "white",
                }
            },
        }, {
            id: "titlech",
            type: "titleswitch",
            look: {
                title: {
                    txt: "title ch"
                },
                value: {
                    txt: "switch",
                    // txtColor: BerColor.Darker,
                    // bgColor: "white",
                }
            },
        }, {
            id: "canvasch",
            type: "canvasswitch",
            look: {
                value: {
                    normalSrc: "img/sys/beach.png",
                    activeSrc: "img/sys/wifi.png",
                    // bgColor: "white",
                    // borderRadius: 0,
                    // padding: 0
                }
            },
        }, {
            id: "titlecanvasch",
            type: "titlecanvasswitch",
            look: {
                title: {
                    txt: "title canvas ch"
                },
                value: {
                    normalSrc: "img/sys/beach.png",
                    activeSrc: "img/sys/wifi.png",
                    // bgColor: "white",
                    // borderRadius: 0,
                    // padding: 0
                }
            },
        }],

        //
        // [{
        //     id: "tcb0",
        //     type: "titlecanvasbutton",
        //     title: "TCB0",
        //     value: "img/sys/beach.png",
        //     activeValue: "img/sys/wifi.png",
        // }, {
        //     id: "tcb1",
        //     type: "titlecanvasbutton",
        //     title: "TCB1",
        //     value: "img/sys/beach.png",
        //     activeValue: "img/sys/wifi.png",
        // }, {
        //     id: "canbtn0",
        //     type: "canvasbutton",
        //     value: "img/sys/beach.png",
        //     activeValue: "img/sys/wifi.png",
        // }, {
        //     id: "canbtn1",
        //     type: "canvasbutton",
        //     value: "img/sys/beach.png",
        //     activeValue: "img/sys/wifi.png",
        // }],
        //
        // [{
        //     id: "titledropdownbox",
        //     type: "titledropdownbox",
        //     title: "TDB",
        //     value: "test",
        //     maxDropdownRows: 1,
        // }, {
        //     id: "dropdownbox",
        //     type: "dropdownbox",
        //     value: "test",
        //     maxDropdownRows: 2,
        // }, {
        //     id: "titledropdownbutton",
        //     type: "titledropdownbutton",
        //     title: "TDBtn",
        //     value: "test",
        //     maxDropdownRows: 3,
        // }, {
        //     id: "dropdownbutton",
        //     type: "dropdownbutton",
        //     value: "test",
        //     maxDropdownRows: 4,
        // }],

    ];

    //
    class BerBerPanel extends BerPanel {
        constructor(parentView, options) {
            super(parentView, options, itemSettings, CustomItems);
            var _this = this;


            // == ui ==


            // == methods ==
            // function search(data) {
            //     var _data = {};
            //     if(data) {
            //         _data = data;
            //         _this.Code = (_data.code ? _data.code : "");
            //         _this.Name = (_data.name ? _data.name : "");
            //     } else {
            //         if(_this.Code) _data.code = _this.Code;
            //         if(_this.Name) _data.name = _this.Name;
            //     }
            //
            //     _this.emit("search", _data);
            //
            // }
            //
            // //
            // this.search = search;
            //
            //
            // // == events ==
            // this.items.reset.on("itemClicked", function() {
            //     _this.Code = "";
            //     _this.Name = "";
            //     _this.Stock = 0;
            //     _this.Sold = 0;
            //     _this.Total = 0;
            //     _this.emit("reset");
            // });
            // this.items.search.on("itemClicked", function() {
            //     search();
            // });

        }

        init() {
            super.init();

        }

        // set Code(val) {
        //     this.items.code.Value = val;
        // }
        // get Code() {
        //     return this.items.code.Value;
        // }
        // set Name(val) {
        //     this.items.name.Value = val;
        // }
        // get Name() {
        //     return this.items.name.Value;
        // }
        //
        // set Stock(val) {
        //     this.items.stock.Value = val;
        // }
        // get Stock() {
        //     return this.items.stock.Value;
        // }
        // set Sold(val) {
        //     this.items.sold.Value = val;
        // }
        // get Sold() {
        //     return this.items.sold.Value;
        // }
        // set Total(val) {
        //     this.items.total.Value = val;
        // }
        // get Total() {
        //     return this.items.total.Value;
        // }


    }


    //
    return BerBerPanel;
})();


//
module.exports = BerBerPanel;
