
require("ber-global");

var DivView = require("./lib/basic/DivView");
var RootView = require("./lib/basic/RootView");
var TextView = require("./lib/basic/TextView");
var ButtonView = require("./lib/basic/ButtonView");
var ToggleView = require("./lib/basic/ToggleView");
var TextBoxView = require("./lib/basic/TextBoxView");
var TextAreaView = require("./lib/basic/TextAreaView");
var ImageView = require("./lib/basic/ImageView");
var CanvasView = require("./lib/basic/CanvasView");
var FileView = require("./lib/basic/FileView");
var IFrameView = require("./lib/basic/IFrameView");
var VideoView = require("./lib/basic/VideoView");

var BasePanel = require("./lib/ext/BasePanel");
var ListItem = require("./lib/ext/ListItem");
var ListPanel = require("./lib/ext/ListPanel");
var CapturePanel = require("./lib/ext/CapturePanel");
var ConfirmPanel = require("./lib/ext/ConfirmPanel");
var AlertPanel = require("./lib/ext/AlertPanel");
var DatePicker = require("./lib/ext/DatePicker");
var DateTimePicker = require("./lib/ext/DateTimePicker");
var GenericPicker = require("./lib/ext/GenericPicker");
var Slider = require("./lib/ext/Slider");
var Calendar = require("./lib/ext/Calendar");
// var CalendarNightSelector = require("./lib/ext/CalendarNightSelector");

// var BerGrid = require("./cus-ui/BerGrid");
// var BerList = require("./cus-ui/BerPanel");
// var BerPanel = require("./cus-ui/BerPanel");

// ====

module.exports = {
    DivView: DivView,
    RootView: RootView,
    TextView: TextView,
    ButtonView: ButtonView,
    ToggleView: ToggleView,
    TextBoxView: TextBoxView,
    TextAreaView: TextAreaView,
    ImageView: ImageView,
    CanvasView: CanvasView,
    FileView: FileView,
    IFrameView: IFrameView,
    VideoView: VideoView,

    BasePanel: BasePanel,
    ListItem: ListItem,
    ListPanel: ListPanel,
    CapturePanel: CapturePanel,
    ConfirmPanel: ConfirmPanel,
    AlertPanel: AlertPanel,
    DatePicker: DatePicker,
    DateTimePicker: DateTimePicker,
    GenericPicker: GenericPicker,
    Slider: Slider,
    Calendar: Calendar,
    // CalendarNightSelector: CalendarNightSelector

    // BerGrid: BerGrid,
    // BerList: BerList,
    // BerPanel: BerPanel

};

// module.exports = {
//     DivView,
//     RootView,
//     TextView,
//     ButtonView,
//     ToggleView,
//     TextBoxView,
//     TextAreaView,
//     ImageView,
//     CanvasView,
//     FileView,
//     IFrameView,
//     VideoView,
//
//     BasePanel,
//     ListItem,
//     ListPanel,
//     CapturePanel,
//     ConfirmPanel,
//     AlertPanel,
//     DatePicker,
//     DateTimePicker,
//     GenericPicker,
//     Slider,
//     Calendar,
//
//     // BerGrid,
//     // BerList,
//     // BerPanel
//
// };
