
var DivView = require("./DivView");

// ====

var RootView = (function() {
    //
    function BodyView() {
        var _this = this;

        this.core = document.body;

        this.getPxW = function () {
            return document.documentElement.offsetWidth;
        }
        this.getPxH = function () {
            return document.documentElement.offsetHeight;
        }

        this.childViews = [];
        this.addChildView = function (view) {
            _this.core.appendChild(view.core);
            _this.childViews.push(view);
        }
        this.redrawChildViews = function() {
            for(var i=0; i<_this.childViews.length; i++) {
                if(_this.childViews[i].redraw) _this.childViews[i].redraw(true);
            }
        }

        // NOTE 當這串在此 class 內執行時, CoreView 的 redraw 的 emit, 只觸發了宣告在其 constructor 內的 on, 沒觸發其 instance 宣告在外面的 on
        // TODO 有空要釐清這個問題 (目前把這拉到最外面即可避免)
        // NOTE 總之為了確保觸發由 instance 宣告的 on, 盡量把會觸發該事件的 call 也放在外面 (外面指的是繼承 EventEmitter 的物件之外)
        // NOTE >>>> 先改回來觀察 <<<<< NOTE
        this.autoResizeChild = true;
        window.addEventListener("resize", function () {
            if (_this.autoResizeChild) _this.redrawChildViews();
        }, false);


        // window.addEventListener('orientationchange', function() {
        //     // switch(window.orientation)  {
        //     //     case -90:
        //     //     case 90:
        //     //         alert('landscape');
        //     //         break;
        //     //     default:
        //     //         alert('portrait');
        //     //     break;
        //     // }
        //
        //     // console.log('orientationchange');
        //     //if (_this.autoResizeChild) {
        //         for (var i = 0; i < _this.childViews.length; i++) {
        //             // console.log('redraw');
        //             _this.childViews[i].redraw();
        //         }
        //     //}
        //
        // });

    }

    //
    class RootView extends DivView {
        constructor() {
            var bodyView = new BodyView();
            super(bodyView);


            // this.setAutoResizeChild = function (auto) {
            //     bodyView.autoResizeChild = auto;
            // }

            this.getBodyView = function() {
                return bodyView;
            }

            //
            // this.emit("root");

        }

        // //
        // emit() {
        //     console.log("[root][emit]", arguments[0]);
        //     super.emit.apply(this, arguments);
        // }

    }


    //
    return RootView;
})();



//
module.exports = RootView;
