
var CoreView = require("../core/CoreView");

// ====

var VideoView = (function() {
    // TODO 視未來需求可加入各事件. ref: https://www.w3schools.com/tags/ref_av_dom.asp
    // (臨時要用可以直接動 this.core)

    //
    class VideoView extends CoreView {
        constructor(parentView, options) {
            super("video", parentView, options);
            var _this = this;

            // == events ==
            // this.domOn("load", function() {
            //     _this.emit("load", event);
            // });

        }

        // == init ==
        init(options) {
            super.init();

            this.core.style.background = "rgb(0, 0, 0)";

            // look
            this.look.src = "";

            // opts
            this.opts.autoplay = true;
            this.opts.loop = false;
            this.opts.muted = false;
            this.opts.controls = false;

        }


        // == redraw ==

        // look
        redrawLook() {
            super.redrawLook();

            this.core.src = this.look.src;

        }

        // opts
        redrawOpts() {
            super.redrawOpts();

            this.core.autoplay = this.opts.autoplay;
            this.core.loop = this.opts.loop;
            this.core.muted = this.opts.muted;
            this.core.controls = this.opts.controls;

        }


        // ====
        play() {
            this.core.play();
        }
        pause() {
            this.core.pause();
        }
        stop() {
            this.core.pause();
            this.core.currentTime = 0;
        }
        rewind() {
            this.core.currentTime = 0;
        }


    }


    //
    return VideoView;
})();


//
module.exports = VideoView;
